//
// ORB.C -- Implementation of ORB functionality.
//

#include "ORB.h"
#include <rts/hpcxx_register.cc>
#include <rts/HPCxx_GlobalPtr.cc>
#include <rts/HPCxx_Sync.cc>
#include <HPCxx_GlobalRefImpl.cc>
#include <invoke.cc>

//template void HPCxx_Sync<HPCxx_GlobalPtr<NameContextImpl> >::write(HPCxx_GlobalPtr<NameContextImpl>&);
//template HPCxx_GlobalPtr<HPCxx_Sync<HPCxx_GlobalPtr<NameContextImpl> > >::HPCxx_GlobalPtr<HPCxx_Sync<HPCxx_GlobalPtr<NameContextImpl> > >(HPCxx_Sync<HPCxx_GlobalPtr<NameContextImpl> >*);


NameContext_ptr ORB::nameServer_s = NULL;
hpcxx_id_t      ORB::nameServerID_s = -1;


// Construct the ORB and associated name server
ORB::ORB(int& beginID)
{
  if (nameServer_s == NULL) {
    nameServer_s = new NameContextImpl(beginID);
  } 
  if (nameServerID_s < 0) {
    beginID = ORB::registerMemberFunctions(beginID);
  }
}

// destructor
ORB::~ORB(void)
{
  if (nameServer_s != NULL) {
    delete nameServer_s;
  }
  nameServer_s = NULL;
}

//
// Returns a reference to the naming service.
//
NameContext_ptr ORB::resolve_initial_references(HPCxx_Group* group)
{
  int i = 0;
  HPCxx_GlobalPtr<NameContextImpl> gp;
  hpcxx_invoke(*(group->getContextID(0)), gp, nameServerID_s, i);
  return new NameContextStub(gp);
}

//
// Returns a reference (global pointer) to the naming service.  This function
// is to be called remotely by client stub.
//
HPCxx_GlobalPtr<NameContextImpl> ORB::resolve_initial_referencesSkel(int i)
{
  HPCxx_GlobalPtr<NameContextImpl> gp((NameContextImpl*) nameServer_s);
  return gp;
}

//
// Returns the naming service.
//
NameContext_ptr ORB::resolve_initial_referencesImpl(void)
{
  return nameServer_s;
}

//
// Registers member functions
//
int ORB::registerMemberFunctions(int beginID)
{
  nameServerID_s = hpcxx_register( ORB::resolve_initial_referencesSkel,
				   beginID++ );
  return beginID;
}


//
// explicit instantiations
//

template class HPCxx_GlobalRefImpl<HPCxx_GlobalPtr<NameContextImpl> >;

template class HPCxx_Sync<HPCxx_GlobalPtr<NameContextImpl> >;

template class HPCxx_GlobalPtr<HPCxx_Sync<HPCxx_GlobalPtr<NameContextImpl> > >;

template 
class HPCxx_GlobalRefImpl<HPCxx_Sync<HPCxx_GlobalPtr<NameContextImpl> > >;

template int hpcxx_register(HPCxx_GlobalPtr<NameContextImpl> (*)(int),int);

template hpcxx_id_t hpcxx_invoke(
    _nexus_startpoint_t&,HPCxx_GlobalPtr<NameContextImpl>&,int,int&
  );

template void hpcxx_pack(
    HPCxx_Buffer&,HPCxx_GlobalPtr<HPCxx_Sync<HPCxx_GlobalPtr<NameContextImpl>
     > >*,int );

template void hpcxx_pack(
    HPCxx_Buffer&,HPCxx_Sync<HPCxx_GlobalPtr<NameContextImpl> >*,int
  );

template int HPCxx_Type<HPCxx_Sync<HPCxx_GlobalPtr<NameContextImpl> > >
    ::registrationID(void);

template int HPCxx_Type<HPCxx_GlobalPtr<NameContextImpl> >
    ::registrationID(void);
