//
// ORB.h -- Declarations of basic ORB types and functionality.
//

#ifndef _ORB_H
#define _ORB_H

#include <hpcxx_rts.h>
#include <CORBA/NameContext.h>


class ORB {
 public:

  // Construct the ORB and associated name server
  ORB(int& beginID);

  // destructor
  ~ORB(void);

  // Returns a reference to the naming service.
  static NameContext_ptr resolve_initial_references(HPCxx_Group* group);

  // Registers member functions
  static int registerMemberFunctions(int beginID);

  static NameContext_ptr resolve_initial_referencesImpl(void);

 private:

  // a pointer to the name server
  static NameContext_ptr nameServer_s;

  // rmi id for resolve_initial_references
  static hpcxx_id_t nameServerID_s;

  static
  HPCxx_GlobalPtr<NameContextImpl> resolve_initial_referencesSkel(int i);


};


#endif	// _ORB_H
