#include "hpcxx_rtsImpl.h"
#include "nexus.h"
#include <unistd.h>  
#include "HPCxx_GlobalPtr.h"
#include "HPCxx_GlobalPtr.cc"
//#include "hpcxx_register.h"
#include "hpcxx_invoke.h"
#include "HPCxx_Sync.h"
#include "iostream.h"
#include "HPCxx_Group.h"
#include "hpcxx_register.cc"
#include "hpcxx_invoke.cc"
#include "hpcxx_invokeImpl.cc"

//#include "hpcxx_invokeImpl.cc"
//#include "hpcxx_rts.h"

// a class on which we will be invoking RMFIs
class C {
  int _me;
public:
  C(){}
  C(int marker):_me(marker) {}
  int foo() {
    // print and return context number
    nexus_printf("here I am in C::foo in context %d\n", _me);
    return _me;
  }
};

// global pointer to that class
typedef HPCxx_GlobalPtr<C> gptr_to_c;
HPCxx_Sync<gptr_to_c> a_truly_global_ptr;

// a global function which will pass the pointer to a different context
int pass_pointer(gptr_to_c ptr) {
  a_truly_global_ptr = ptr;
  return 0;
}

int main(int argc, char *argv[]){
  HPCxx_Group* g;
  hpcxx_init(argc, argv, g);
  
  nexus_printf("%d: here I am \n", g->getLocalIndex());
  nexus_printf("%d: number of nodes:%d \n", g->getLocalIndex(), 
               g->getNumContexts());
  hpcxx_barrier();

  C* x = new C(g->getLocalIndex());
  HPCxx_GlobalPtr<C> c_gptr(x);

  nexus_printf("pointers created\n");
  hpcxx_barrier();
  // register functions
   int pass_pointer_id = hpcxx_register(pass_pointer, 24);
   int foo_id = hpcxx_register(C::foo, 25);
   nexus_printf("registered functions\n");
   hpcxx_barrier();

   int res;


   if (g->getLocalIndex() == 0) { // context 0
     nexus_printf("sending the global pointer to context 1\n");
     int result1 = hpcxx_invoke(*(g->getContextID(1)), res,
                               pass_pointer_id, c_gptr);
     int result2 = hpcxx_invoke(*(g->getContextID(2)), res,
                               pass_pointer_id, c_gptr);
     nexus_printf("pointer was sent\n");
   } else { // context 1
     // invoke RMF on the global pointer from context 1
     gptr_to_c x = a_truly_global_ptr;
     int result = hpcxx_minvoke(&(x), res, foo_id);
     nexus_printf("result is %d\n", res);
   }
  
  hpcxx_barrier();
  cout << "********** done" << endl;
  hpcxx_exit();
  return(0);
} /* main() */
  
  
