#include "hpcxx_rtsImpl.h"
#include "nexus.h"
#include <unistd.h>  
//#include "gptr.h"
#include "HPCxx_GlobalPtr.h"
#include "HPCxx_GlobalPtr.cc"
#include "hpcxx_invoke.h"
#include "HPCxx_Sync.h"
#include "iostream.h"

// global pointer to that class
typedef HPCxx_GlobalPtr<int> gptr_to_c;
HPCxx_Sync<gptr_to_c> a_truly_global_ptr;

int pass_pointer(gptr_to_c ptr) {
  a_truly_global_ptr = ptr;
  return 0;
}

int main(int argc, char *argv[]){
  HPCxx_Group* g;
  hpcxx_init(argc, argv, g);
  
  nexus_printf("%d: here I am \n", g->getLocalIndex());
  nexus_printf("%d: number of nodes:%d \n", g->getLocalIndex(), 
               g->getNumContexts());
  hpcxx_barrier();

  int* my_int = new int;
  *my_int = g->getLocalIndex() + 6;
  HPCxx_GlobalPtr<int> int_gptr(my_int);
  int pass_pointer_id = hpcxx_register(pass_pointer, 24);
  hpcxx_barrier();

  int res;

  if (g->getLocalIndex() == 0) { // context 0
    nexus_printf("sending the global pointer to context 1\n");
    int result1 = hpcxx_invoke(*(g->getContextID(1)), res,
                               pass_pointer_id, int_gptr);
  
    nexus_printf("pointer was sent\n");
   } else { // context 1
     gptr_to_c gptr = (gptr_to_c)a_truly_global_ptr;
    cout << "This is the content of the global pointer " <<
      *(gptr) << endl;
    cout << "and now I am going to modify it" << endl;
    *(gptr) = 5;
    cout << "the content now is " << *(gptr) <<
      endl; 
   }
  hpcxx_barrier();
  cout << "**********done" << endl;
  hpcxx_exit();
}
