// HPC++ Run Time Sytem Library
// Extreme! Computing Lab - Computer Science Department
// Copyright (c) 1997 Indiana University
// Authors: Pete Beckman, Dennis Gannon, Todd Green, and Liz Johnson
//
// $Id: HPCxx_BufferImpl.h,v 1.1 1998/06/23 00:03:08 ejohnson Exp $

#ifndef __HPCXX_BUFFERIMPL_H_
#define __HPCXX_BUFFERIMPL_H_

#include <nexus.h>
#include <hpcxx_types.h>

class HPCxx_BufferImpl {
public:
  nexus_buffer_t * buffer_;

public:
  HPCxx_BufferImpl(int bufSize);
  HPCxx_BufferImpl(nexus_buffer_t &buffer);

  ~HPCxx_BufferImpl();

  int pack(const HPCxx_ContextID *data, int count);
  int pack(const float *data, int count);
  int pack(const double *data, int count);
  int pack(const short *data, int count);
  int pack(const u_short *data, int count);
  int pack(const int *data, int count);
  int pack(const u_int *data, int count);
  int pack(const long *data, int count);
  int pack(const u_long *data, int count);
  int pack(const char *data, int count);
  int pack(const u_char *data, int count);

  void unpack(HPCxx_ContextID *data, int count);
  void unpack(float *data, int count);
  void unpack(double *data, int count);
  void unpack(short *data, int count);
  void unpack(u_short *data, int count);
  void unpack(int *data, int count);
  void unpack(u_int *data, int count);
  void unpack(long *data, int count);
  void unpack(u_long *data, int count);
  void unpack(char *data, int count);
  void unpack(u_char *data, int count);
};

#endif
