// HPC++ Run Time Sytem Library
// Extreme! Computing Lab - Computer Science Department
// Copyright (c) 1997 Indiana University
// Authors: Pete Beckman, Dennis Gannon, Todd Green, and Liz Johnson
//
// $Id: HPCxx_CondImpl.C,v 1.2 1998/07/09 23:53:49 sameer Exp $

#include <HPCxx_Profile.h>
#include <HPCxx_CondImpl.h>

HPCxx_CondImpl::HPCxx_CondImpl()
{
  TAU_PROFILE("HPCxx_CondImpl::HPCxx_CondImpl()", "void ()", TAU_HPCXX);
  nexus_cond_init(&cond_, NULL);
}

HPCxx_CondImpl::HPCxx_CondImpl(const HPCxx_CondImpl& cond) : cond_(cond.cond_)
{
  TAU_PROFILE("HPCxx_CondImpl::HPCxx_CondImpl()", "void (HPCxx_CondImpl& )", 
    TAU_HPCXX);

}

HPCxx_CondImpl::~HPCxx_CondImpl()
{
  TAU_PROFILE("HPCxx_CondImpl::~HPCxx_CondImpl()", "void ()", TAU_HPCXX);
  
  nexus_cond_destroy(&cond_);
}

HPCxx_CondImpl& HPCxx_CondImpl::operator=(const HPCxx_CondImpl& cond)
{
  TAU_PROFILE("HPCxx_CondImpl::operator=()", "HPCxx_CondImpl& (HPCxx_CondImpl& )", TAU_HPCXX);
  if (this == &cond) return *this; // self-assignment
  //((HPCXX_Cond&) *this) = cond;  // Copy any data in HPCxx_Cond
  
  nexus_cond_destroy(&cond_);
  cond_ = cond.cond_;

  return *this;
}

int HPCxx_CondImpl::wait(HPCxx_MutexImpl &mutex)
{
  TAU_PROFILE("HPCxx_CondImpl::wait()", "int (HPCxx_MutexImpl & )", TAU_HPCXX);
  return(nexus_cond_wait(&cond_, &(mutex.mutex_)));
}

int HPCxx_CondImpl::signal()
{
  TAU_PROFILE("HPCxx_CondImpl::signal()", "int ()", TAU_HPCXX);
  return(nexus_cond_signal(&cond_));
}

int HPCxx_CondImpl::broadcast()
{
  TAU_PROFILE("HPCxx_CondImpl::broadcast()", "int ()", TAU_HPCXX);
  return(nexus_cond_broadcast(&cond_));
}
