// HPC++ Run Time Sytem Library
// Extreme! Computing Lab - Computer Science Department
// Copyright (c) 1997 Indiana University
// Authors: Pete Beckman, Dennis Gannon, Todd Green, and Liz Johnson
//
// $Id: HPCxx_MutexImpl.h,v 1.1 1998/06/23 00:03:17 ejohnson Exp $

#ifndef __HPCXX_MUTEXIMPL_H_
#define __HPCXX_MUTEXIMPL_H_

#include <nexus.h>

class HPCxx_CondImpl;

class HPCxx_MutexImpl {
private:
  nexus_mutex_t     mutex_;
  // Nexus currently doesn't support init'ing mutexattrs
  //nexus_mutexattr_t attr_;

public:
  HPCxx_MutexImpl();
  HPCxx_MutexImpl(const HPCxx_MutexImpl& mutex);
  ~HPCxx_MutexImpl();

  HPCxx_MutexImpl& operator=(const HPCxx_MutexImpl& mutex);

  int lock();
  int unlock();

  friend HPCxx_CondImpl;
};

#endif
