// HPC++ Run Time Sytem Library
// Extreme! Computing Lab - Computer Science Department
// Copyright (c) 1997 Indiana University
// Authors: Pete Beckman, Dennis Gannon, Todd Green, and Liz Johnson
//
// $Id: HPCxx_NodeImpl.h,v 1.1 1998/06/23 00:03:21 ejohnson Exp $

#ifndef __HPCXX_NODEIMPL_H_
#define __HPCXX_NODEIMPL_H_

#include <hpcxx_types.h>
#include <HPCxx_GlobalPtr.h>

class HPCxx_NodeImpl {
private:
  void *node_;

public:
  HPCxx_NodeImpl();
  HPCxx_NodeImpl(const HPCxx_NodeImpl &node);
  ~HPCxx_NodeImpl();
  
  // Return true if the context is local to this node
  bool contextIsLocal(const HPCxx_ContextID &id);

  // Return the number of contexts in this node 
  int getNumContexts();

  // Null terminated list of the contexts in this node
  // The caller of this function must 'delete []' the memory
  HPCxx_ContextID *getContexts();

  // Create a new context and add it to this node
  // FIXME - currently not implemented
  int addContext();

  // Create a new context and run the specified executable
  // FIXME - currently not implemented
  int addContext(const char *exePath);
};

#endif
