// HPC++ Run Time System Library
// Extreme! Computing Lab - Computer Science Department
// Copyright (c) 1997 Indiana University
// Authors: Pete Beckman, Dennis Gannon, Todd Green, and Liz Johnson
//
// $Id: hpcxx_invokeImpl.C,v 1.3 1998/08/07 20:08:14 sameer Exp $

#include <HPCxx_Profile.h>
#include <HPCxx_Buffer.h>
#include <iostream.h>


// Global pointer pack and unpack code.

void hpcxx_pack(HPCxx_Buffer &buffer, HPCxx_ContextID *cid, int count){
  TAU_PROFILE("hpcxx_pack()", "void (HPCxx_Buffer, HPCxx_ContextID *, int",
    TAU_HPCXX);
  int sz = count*nexus_sizeof_startpoint(&(cid[0]), 1)+32;
  if(nexus_check_buffer_size(buffer.impl_.buffer_, sz, sz, 0, 0) < 0)
    cout << "global pointer pack failed" << endl;
  
  for(int i = 0; i < count; i++){
    nexus_startpoint_t *sp = new nexus_startpoint_t;
    nexus_startpoint_copy(sp, &(cid[i]));
    nexus_put_startpoint_transfer(buffer.impl_.buffer_ , sp, 1);
  }
}

void hpcxx_unpack(HPCxx_Buffer &buffer, HPCxx_ContextID *cid, int count){
  TAU_PROFILE("hpcxx_unpack()", "void (HPCxx_Buffer, HPCxx_ContextID *, int",
    TAU_HPCXX);
  for(int i = 0; i < count; i++) {
    nexus_get_startpoint(buffer.impl_.buffer_, &(cid[i]), 1);
  }
}



