// HPC++ Run Time Sytem Library (pthread)
// Extreme! Computing Lab - Computer Science Department
// Copyright (c) 1997 Indiana University
// Authors: Pete Beckman, Dennis Gannon, Todd Green, and Liz Johnson
//
// $Id: hpcxx_rtsImpl.C,v 1.1 1998/07/02 16:35:59 rasmussn Exp $

#include <iostream.h>
#include <hpcxx_types.h>
#include <hpcxx_rts.h>
#include <hpcxx_rtsImpl.h>

// explicit template instantiations

#include <HPCxx_SyncQ.cc>
template class HPCxx_SyncQ<int>;


//---- hpcxx_init -------------------------------------------------------------
// Initializes an HPC++ session.  This function should be called before other
// HPC++ calls are made.  When session is over, call hpcxx_exit.
//-----------------------------------------------------------------------------
int hpcxx_init(int& argc, char**& argv, HPCxx_Group*& group)
{
  return HPCXX_SUCCESS;
}


//---- hpcxx_exit -------------------------------------------------------------
// Cleans up at the end of a session.  This function should be called after
// all HPC++ calls have been made.
//-----------------------------------------------------------------------------
int hpcxx_exit(HPCxx_Group*& group)
{
  return HPCXX_SUCCESS;
}


//---- hpcxx_msg --------------------------------------------------------------
// Prints out an error message.
//-----------------------------------------------------------------------------
void hpcxx_msg(const char *msg)
{
  cerr << msg << endl;
}


//---- hpcxx_malloc -----------------------------------------------------------
// Allocates memory.
//-----------------------------------------------------------------------------
void* hpcxx_malloc(size_t size)
{
  return malloc(size);
}
