// HPC++ Run Time Sytem Library
// Extreme! Computing Lab - Computer Science Department
// Copyright (c) 1997 Indiana University
// Authors: Pete Beckman, Dennis Gannon, Todd Green, and Liz Johnson
//
// $Id: HPCxx_CondImpl.h,v 1.1 1998/06/23 00:08:18 ejohnson Exp $

#ifndef __HPCXX_CONDIMPL_H_
#define __HPCXX_CONDIMPL_H_

#include <HPCxx_MutexImpl.h>

// NexusLite implementation of condition variables does not look good at
// all; it will poll for any input and signal when any sort of input has
// been received, but we don't want to poll for any input, we want want to
// poll for a specific input, so when there are many things we are waiting
// for this approach won't work. Hand-implemented condition variable here.
// KK

class HPCxx_CondImpl {
private:
  int _signal;

public:
  HPCxx_CondImpl();
  HPCxx_CondImpl(const HPCxx_CondImpl& cond);

  virtual ~HPCxx_CondImpl();

  HPCxx_CondImpl& operator=(const HPCxx_CondImpl& cond);

  virtual int wait(HPCxx_MutexImpl& mutex);
  virtual int signal();
  virtual int broadcast();
};

#endif
