// HPC++ Run Time Sytem Library
// Extreme! Computing Lab - Computer Science Department
// Copyright (c) 1997 Indiana University
// Authors: Pete Beckman, Dennis Gannon, Todd Green, and Liz Johnson
//
// $Id: HPCxx_MutexImpl.C,v 1.1 1998/06/23 00:08:53 ejohnson Exp $

#include <HPCxx_MutexImpl.h>

HPCxx_MutexImpl::HPCxx_MutexImpl(void)
{
  pthread_mutexattr_init(&attr_);
  pthread_mutex_init(&mutex_, &attr_);
}

// WARNING, think about what this should do
HPCxx_MutexImpl::HPCxx_MutexImpl(const HPCxx_MutexImpl& mutex)
  : attr_(mutex.attr_), mutex_(mutex.mutex_)
{
}

HPCxx_MutexImpl& HPCxx_MutexImpl::operator=(const HPCxx_MutexImpl& mutex)
{
  if (this == &mutex) return *this; // check for self-assignment

  // WARNING, consider what happens when mutex is deleted, will this mutex
  // still work?
  attr_ = mutex.attr_;
  mutex_ = mutex.mutex_;

  //
  // mutex is const so destroying should be considered illegal
  //
  // pthread_mutex_destroy(&mutex_);
  // pthread_mutexattr_destroy(&attr_);

  return *this;
}

HPCxx_MutexImpl::~HPCxx_MutexImpl(void)
{
  pthread_mutex_destroy(&mutex_);
  pthread_mutexattr_destroy(&attr_);
}

int HPCxx_MutexImpl::lock(void)
{
  return(pthread_mutex_lock(&mutex_));
}

int HPCxx_MutexImpl::unlock(void)
{
  return(pthread_mutex_unlock(&mutex_));
}
