// HPC++ Run Time Sytem Library
// Extreme! Computing Lab - Computer Science Department
// Copyright (c) 1997 Indiana University
// Authors: Pete Beckman, Dennis Gannon, Todd Green, and Liz Johnson
//
// $Id: HPCxx_MutexImpl.h,v 1.1 1998/06/23 00:08:58 ejohnson Exp $

#ifndef __HPCXX_MUTEXIMPL_H_
#define __HPCXX_MUTEXIMPL_H_

#include <pthread.h>

class HPCxx_CondImpl;

class HPCxx_MutexImpl {
private:
  pthread_mutex_t     mutex_;
  pthread_mutexattr_t attr_;

public:
  HPCxx_MutexImpl(void);
  HPCxx_MutexImpl(const HPCxx_MutexImpl& mutex);
  ~HPCxx_MutexImpl(void);

  HPCxx_MutexImpl& operator=(const HPCxx_MutexImpl& mutex);

  int lock(void);
  int unlock(void);

  friend HPCxx_CondImpl;
};

#endif
