#include <stream.h>
#include <stdio.h>
#include "Tulip_Barrier.h"
#include "Tulip_Context.h"
#include "BarrierTest.h"
#include "Tulip_iolock.h"

#define TRIALS 100
#define SAMPLES 10

extern Tulip_Barrier TheBarrier;
extern Tulip_Context SystemContext;
int testers = 0;



main(int argc, char** argv)
{
    int cpus = (argc > 1) ? atoi(argv[1]) : 1;
    int from = (argc > 3) ? atoi(argv[3]) : 50;
    int to = (argc > 4) ? atoi(argv[4]) : (from + 100);
    int by = (argc > 5) ? atoi(argv[5]) : 50;

    systemContext.addNCpus(cpus-1);
    cerr << "From = " << from << " and to = " << to << "\n";
    cerr << "with " << cpus << " cpus\n";
    char buffer[30];

    for (int i = from; i <= to; i += by ) {
        cerr << "i = " << i << "\n";
	TheBarrier.height(i+1);
	cerr << "Build testers..i = " << i << "from,to = " << from << "," << to <<"\n";
	while( testers < i) {
	    sprintf(buffer, "Barrier-Test %d", testers);
	    SystemContext.add(new BarrierTest(testers,buffer));
	    testers++;
	}
	cerr << "Let everyone rendezvous\n";
	TheBarrier.rendezvous();
	cerr << "Now, begin the tests..\n";
	//
	// start collecting sampls
	//
	for (int sample = 0; sample < SAMPLES; sample++ ) {
	  cerr << lock << ".." << sample << ".." << flush << unlock;
	  for (int trial = 0; trial < TRIALS; trial++) {
	    TheBarrier.rendezvous();
	  }
	}
    }
    cerr << "Exiting..\n";
    BarrierTest::done = 1;
    systemContext.wait();
    cerr << "Done!\n";
    extern Tulip_Barrier TheBarrier;
    cerr << "There are " << TheBarrier.count() << " tasks at the barrier \n";
}

