//
//	A timing test for barrier. Everything is in the one file.
//

#include "Gauss.h"
#include "Tulip_Context.h"
#include "Tulip_Barrier.h"
#include <stdio.h>

Tulip_Barrier TheBarrier(0);
Tulip_Barrier GaussBarrier(0);

extern float **array;

Gauss::Gauss(char *name, int p, int matrix_x, int matrix_y, int numThreads)
: Tulip_Thread(name)
{
    pid = p;
    X = matrix_x;
    Y = matrix_y;
    noThreads = numThreads;
}

void
Gauss::run()
{

    cerr << "Gauss " << pid << " starts\n";
    
    int i,j,k,l,next;
    float mult;

    GaussBarrier.rendezvous();
    
    for (k=1; k < X; k++) {
	i = k;
        l = k-1;
        while ((i%noThreads) != pid) i++;
        next = i;
        for (i=next; i<X; i+=noThreads) {
            mult = array[i][l]/array[l][l];
	    for (j=l; j<X; j++) {
    	       array[i][j] -=  array[l][j] *mult;
	    }
        }
        GaussBarrier.rendezvous();
    }
    TheBarrier.rendezvous();
    

}
