#include <stream.h>
#include "Tulip_Context.h"
#include "Tulip_Barrier.h"
#include "Tulip_Timers.h"
#include "Tulip_iolock.h"
#include "Gauss.h"
#include "Tulip_iolock.h"


extern Tulip_Barrier TheBarrier;
extern Tulip_Barrier GaussBarrier;

float **array;

int X,Y;
void PrintMatrix()
{
    if (X > 30) return;
    cout << "Content of Matrix: \n\n";
    cout.precision(2);
    for(int i=0; i<X;  i++) {
      for(int j=0; j<Y; j++) {
        cerr << " " << array[i][j];
      }
      cerr << "\n";
    }

}


main(int argc, char** argv)
{
    int cpus = (argc > 1) ? atoi(argv[1]) : 1;
    int debug = (argc > 2) ? atoi(argv[2]) : 0;
    X = (argc > 3) ? atoi(argv[3]) : 4;
    Y = (argc > 4) ? atoi(argv[4]) : 4;
    int noThreads = (argc > 5) ? atoi(argv[5]) : 4;

    double start = Tulip_StartTimer();
    systemContext.addNCpus(cpus-1);
    int i,j;
    cout << "X dim: " << X << "\n";
    cout << "Y dim: " << Y << "\n";
    cout << "Using " << noThreads << " threads\n";

    array = (float **)malloc((X)*sizeof(float *));

    if (array == (float **)-1)
      cerr << "OOPSS\n";
    
    for(i=0;i<X;i++)
      {
	array[i] = (float *)malloc((Y)*sizeof(float));
	if (array[i] == (float *)-1)
	  cerr << "OOPS 1 " << i << " \n";
      }
    
    for(i=0;i<X;i++)
      for(j=0;j<Y;j++)
	array[i][j] = (float )rand();
    
    cerr << lock << "Initial " << unlock;
    PrintMatrix();
    
    TheBarrier.height(noThreads+1);
    GaussBarrier.height(noThreads);

    for (i=0; i < noThreads; i++) {
      char buff[30];
      sprintf(buff,"Gauss %d", i);
      Tulip_Context::add(new Gauss(buff,i,X,Y,noThreads));
    }
    TheBarrier.rendezvous();
    systemContext.wait();
    double eltime = Tulip_StopTimer(start);

    cerr << lock << "Total time elapsed in secs: " << eltime << "\n"<< unlock; 
    cerr << lock << "Final " << unlock;
    PrintMatrix();
    cout << "Done!\n";

    return (0);
}

