#include <iostream.h>
#include "Tulip_Context.h"
#include "Tulip_Barrier.h"
#include "Tulip_Timers.h"
#include "Tulip_iolock.h"
#include "Data.h"
#include "RedBlackSOR.h"

GlobalData Data;

Tulip_Barrier TheBarrier;

main(int argc, char** argv)
{

    int cpus = (argc > 1) ? atoi(argv[1]) : 1;
    int debug = (argc > 2) ? atoi(argv[2]) : 0;
    int low = (argc > 3) ? atoi(argv[3]) : 0;
    int high = (argc > 4) ? atoi(argv[4]) : 1024;
    int stride = (argc > 5) ? atoi(argv[5]) : 1;
    int loop = (argc > 6) ? atoi(argv[6]) : 10;

    if (debug)
      systemContext.startVerbose();
    double start = Tulip_StartTimer();
    systemContext.addNCpus(cpus-1);
    Data.data = new (double [(high+4)*(high+4)]);
    for (int i=0; i < (high+4)*(high+4); i++) {
      Data.data[i] = 10;
    }

    int grain = (high-low)/cpus;
    if (grain%2) grain++;
    int lo = low;

    for (int chunk = 0; chunk < cpus; chunk++, lo += grain) {
	RedBlackSOR *red = new RedBlackSOR(lo, 
					   lo+grain-2, 
					   low, 
					   high-1, 
					   stride, 
					   loop, 
					   chunk,
					   cpus);
	Tulip_Context::add(red);
    }

    systemContext.wait();
    double eltime = Tulip_StopTimer(start);

    cout << high << " "<< cpus << " " << eltime << "\n" << flush;
    if (debug) {
       cout << "\n";
       for (i=0; i< high; i++) {
         for(int j=0; j<high; j++) {
	   cout << data(i,j) << " ";
         }
         cout << "\n";
       }
    }
    cout << "Done!\n";
}









