
#ifdef __GNUG__
#  pragma implementation
#endif

#include <Tulip_iolock.h>
#include "Tulip_Context.h"
#include "Tulip_Barrier.h"
#include <stdio.h>
#include "Data.h"
#include "RedBlackSOR.h"


class Stuff;
class RedBlackSOR;
extern GlobalData Data;

extern  Tulip_Barrier TheBarrier;
//
// constructor for RedBlackSOR.
//
RedBlackSOR::RedBlackSOR(int _lo, int _hi, int _glo, int _ghi, int _st, int _it, int _chnk,int _num)  : Tulip_Thread("RedBlackSOR")
{

     low = _lo;
     high = _hi;
     globallow = _glo;
     globalhigh = _ghi;
     stride = _st;
     iterations = _it;
     NumCpus = _num;
     chunk = _chnk;
}

void RedBlackSOR::run()
{

     int i, j;

     TheBarrier.height(NumCpus);

     /* Computation assuming omega = 0 */
    
     for (int c = 0; c < iterations; c++) { 
       //        cout << lock << "it,me" << iterations<< "," << MYID << "\n" << flush << unlock;

	///////////////////////////////////////////////////////////////////////
	/* Start computing the RED elements */
	for (i = low; i <= high; i += 2) {
	    for (j = 0; j <=  globalhigh; j += 2) {

	      // Four Point Stencil Computation: 
	      //  north, south, east, west are the values from neighbors 

	       data(i,j) = (data(i-1,j) + data(i,j+1) + data(i+1,j) + data(i,j-1)) /4.0;
	       data(i+1,j+1) = (data(i,j+1) + data(i+1,j+2) + data(i+2,j+1) + data(i+1,j))/4.0;

	    }
	}

	TheBarrier.rendezvous();

        ///////////////////////////////////////////////////////////////////////
	// Start computing the BLACK elements 
	for (i = low; i <= high; i += 2) {
	    for (j = 1;  j <= globalhigh; j += 2) {
	       data(i,j) = (data(i-1,j) + data(i,j+1) + data(i+1,j) + data(i,j-1))/4.0;

	       data(i+1,j-1) = (data(i,j-1) + data(i+1,j) + data(i+2,j-1) + data(i+1,j-2))/4.0;

	    }
	}

	TheBarrier.rendezvous();
     }
}


