#include <stdio.h>
#include <stdlib.h>
#include "Tulip_Context.h"
#include "Tulip_Timers.h"
#include "Tulip_iolock.h"


class Dome : public Tulip_Thread {
public:
  Dome() : Tulip_Thread("") {
    return;
  }
  virtual void run() {
    BEGIN_PRINT
    cerr << "Running a thread\n" << flush;
    END_PRINT
  }
};


void main(int argc, char** argv)
{
  int cpus = (argc > 1) ? atoi(argv[1]) : 1;
  int debug = (argc > 2) ? atoi(argv[2]) : 0;
  int NPROCS = (argc > 3) ? atoi(argv[3]) : 1000;
  Tulip_ThreadPtr *domes = new Tulip_ThreadPtr[NPROCS];

  fprintf(stderr,"About to start scheduling..\n");
  //  systemContext.startVerbose();
  systemContext.addNCpus(cpus-1);
  double start = Tulip_StartTimer();
  for (int i=0; i < NPROCS; i++) {
    domes[i] = new Dome();
    systemContext.add(domes[i]);

  }
  yield();
  //  systemContext.endVerbose();
  for (i=0; i< NPROCS; i++) {
    join(*domes[i]);
  }
  systemContext.wait();
  double delta = Tulip_StopTimer(start);
  fprintf(stderr,"Took %f seconds\n", delta);
  fprintf(stderr,"Back in main, about to exit\n");
}
