#include "Tulip_Timers.h"
#include <stdio.h>
#include <stdlib.h>
#include "Tulip_Thread.h"
#include "Tulip_Context.h"
#include "Tulip_CSem.h"


class MyThread: public Tulip_Thread{
  Tulip_CSem *c;
  int my_num;
public:
  MyThread( Tulip_CSem * s , int m, char *name ):  Tulip_Thread(name){
    my_num = m;
    c = s;
  }
  void run(){
    BEGIN_PRINT
      cerr<< "hi from thread " << my_num << "\n";
    END_PRINT
    (*c)+=1;
  }
};

int main(int argc, char *argv[]){
  Tulip_CSem c;
  int cpus = (argc > 1) ? atoi(argv[1]) : 1;
  int nThreads = (argc > 2) ? atoi(argv[2]) : 20;
  int debug = (argc > 3) ? atoi(argv[3]) : 0;

  c.set_height(nThreads);
  BEGIN_PRINT
  cerr << "About to start scheduling..\n";
  END_PRINT
  double start = Tulip_StartTimer();
  systemContext.addNCpus(cpus-1);
  for(int i = 0; i < nThreads; i++){
    Tulip_Context::add(new MyThread(&c, i,""));
  }
  BEGIN_PRINT
  cerr << "About to wait on a CSem variable\n";
  END_PRINT
  c.wait();
  BEGIN_PRINT
  cerr << "Returned from CSem wait\n";
  END_PRINT
  double delta = Tulip_StopTimer(start);
  systemContext.wait();
  BEGIN_PRINT
    cerr << "Took " << delta << " seconds\n";
  END_PRINT
} /* main() */


