#include "Tulip_Timers.h"
#include <stdio.h>
#include <stdlib.h>
#include "Tulip_Thread.h"
#include "Tulip_Context.h"
#include "Tulip_Sync.h"


class MyThread: public Tulip_Thread {
  Tulip_Sync<float> *c;
  int my_num;
public:
  MyThread( Tulip_Sync<float> * s , int m, char *name ):  Tulip_Thread(name){
    my_num = m;
    c = s;
    cout << "Thread " << my_num << "created \n" << flush;
  }
  void run(){
    BEGIN_PRINT
      cout << "Thread " << my_num <<" started and waiting for signal...\n" << flush;
    END_PRINT

    float val = c->read();
    BEGIN_PRINT
      cout << "Thread " << my_num <<", value of c is " << val << "\n" << flush;
    END_PRINT
    
  }
};

int main(int argc, char *argv[]){

  Tulip_Sync<float> c;

  int cpus = (argc > 1) ? atoi(argv[1]) : 1;
  int nThreads = (argc > 2) ? atoi(argv[2]) : 20;
  int debug = (argc > 3) ? atoi(argv[3]) : 0;

  cout << "About to start scheduling..\n";
  double start = Tulip_StartTimer();
  systemContext.addNCpus(cpus-1);
  for(int i = 0; i < nThreads; i++){
    Tulip_Context::add(new MyThread(&c, i,""));
  }
  for (long j=0; j<10000000; j++);
  c.write(10.0);
  systemContext.wait();
  double delta = Tulip_StopTimer(start);
  
  fprintf(stderr,"Took %f seconds\n", delta);
  fprintf(stderr,"Back in main, about to exit\n");
  return(0);
} /* main() */


