#include <stdio.h>
#include <stdlib.h>
#include "Tulip_Context.h"
#include "Tulip_Timers.h"
#include "Tulip_Barrier.h"
#include <unistd.h>

extern  void millisec();

#define NB_MILLISEC  0
#define NB_THREADS   9
#define NB_CPUS      7
#define NB_BARRIER   1

Tulip_Barrier MyBarrier1(NB_THREADS);
//Tulip_SpinBarrier MyBarrier2(NB_THREADS);

class MyTask : public Tulip_Thread {
  int myid;
public:

  MyTask(int iv, char *name) : Tulip_Thread(name) {
    myid = iv;
    return;
  }

  virtual void run() {
    int j;

    for (j=0;j<NB_BARRIER; j++){
      //for (i=0;i<(NB_MILLISEC); i++){
      //millisec();
      //}

      if (myid == 0) {
	BEGIN_PRINT
	  cout << "Thread "<< myid << "is sleeping\n" << flush;
	END_PRINT	  
	  for (long k=0; k< 100000000; k++);
	BEGIN_PRINT
	  cout << "Thread "<< myid << "is done sleeping\n" << flush;
	END_PRINT	  
      }
      MyBarrier1.rendezvous();
      BEGIN_PRINT
	cout << "Thread "<< myid << "after barrier\n" << flush;
      END_PRINT	  
    }
  }
};
void main(int argc, char** argv)
{

  int cpus = (argc > 1) ? atoi(argv[1]) : NB_CPUS;
  int debug = (argc > 2) ? atoi(argv[2]) : 0;
  int NPROCS = (argc > 3) ? atoi(argv[3]) : NB_THREADS;  

  printf("starting\n");
  double start = Tulip_StartTimer();
  systemContext.addNCpus(cpus-1);
  MyBarrier1.height(NB_THREADS);
  for (int i=0; i < NB_THREADS; i++) {
    char *buffer = new char[20];
    sprintf(buffer,"Thread %d",i);
    Tulip_Thread *task = new MyTask(i, buffer);
    Tulip_Context::add(task);
  }
  systemContext.wait();
  double delta = Tulip_StopTimer(start);
  fprintf(stderr,"Took %f seconds\n", delta);

  exit(0);
}

