#include <stdio.h>
#include <stdlib.h>
#include "Context.h"
#include "Tulip_Timers.h"
#include "Tulip_Mutex.h"

#undef DEBUG
#define DEBUG
#define TRYS 10

#define HOOK_FUNC ding
#define HOOK_DATA 1

#if 0
#define HOOK_FUNC NULL
#define HOOK_DATA NULL
#endif

#define STKSIZE 800000
unsigned long *stk0;
unsigned long *stk1;

Tulip_NonPremptiveContext *context[2];
Tulip_NonPremptiveContext *syscontext;

static int counter = 0;

void
ding(int x)
{
  fprintf(stderr,"ding %d\n", x);
}

static void
dome(int me)
{
  int other = -99;

  switch (me) {
  case 0:
    other = 1;
    break;

  case 1:
    other = 0;
    break;

  default:
    abort();
  }

  for(;;) {
#ifdef DEBUG
    fprintf(stdout,"I have id %d\n", me);
#endif

    counter++;

    if (counter > TRYS ) {
#ifdef DEBUG
      fprintf(stdout,"Return to syscontext\n");
#endif
      Tulip_SwitchTo(syscontext, (Tulip_voidfuncptr *)HOOK_FUNC, (void *)HOOK_DATA, context[me]);
    } else {
#ifdef DEBUG
      fprintf(stdout,"Switch %d -> %d\n", me, other);
#endif
      Tulip_SwitchTo(context[other], (Tulip_voidfuncptr *)HOOK_FUNC, (void *)HOOK_DATA, context[me]);
    }
  }
}

void
main()
{
  double start;
  double delta;

  stk0= (unsigned long *) malloc(sizeof(unsigned long) * STKSIZE);
  stk1 = (unsigned long *) malloc(sizeof(unsigned long) * STKSIZE);


  context[0]= (Tulip_NonPremptiveContext *)
    malloc(sizeof(Tulip_NonPremptiveContext));

  context[1]= (Tulip_NonPremptiveContext *)
    malloc(sizeof(Tulip_NonPremptiveContext));

  syscontext= (Tulip_NonPremptiveContext *)
    malloc(sizeof(Tulip_NonPremptiveContext));

  fprintf(stderr,"stk0 = %p\n",stk0);
  fprintf(stderr,"stk1 = %p\n",stk1);

  fprintf(stderr,"context[0] = %p\n",context[0]);
  fprintf(stderr,"context[1] = %p\n",context[1]);
  fprintf(stderr,"syscontext = %p\n",syscontext);

  Tulip_InitNP(context[0], (Tulip_U64*) &stk0[STKSIZE-1],
	       dome, (void *) 0);

  Tulip_InitNP(context[1], (Tulip_U64*) &stk1[STKSIZE-1],
	       dome, (void *) 1);

  Tulip_SetNonPremptiveResume(syscontext);

  fprintf(stderr,"About to switch to 0\n");
  start = Tulip_StartTimer();
  Tulip_SwitchTo(context[0], NULL, NULL, syscontext);
  delta = Tulip_StopTimer(start);

  fprintf(stderr,"Took %f seconds\n", delta);
  fprintf(stderr,"Or, %f seconds per call\n", delta/TRYS);

  fprintf(stderr,"Back in main, about to exit\n");

  Tulip_Mutex testlock;
  fprintf(stderr,"Going to try a lock\n");
  testlock.lock();
  fprintf(stderr,"Got it.., lock =%ld\n", (long)&testlock);
  fprintf(stderr,"Going to try a lock again...(block?)\n");
  testlock.lock();
}
