#include "Tulip_Timers.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "Tulip_Thread.h"
#include "Tulip_Context.h"
#include "Tulip_Mutex.h"

Tulip_Mutex mutex;

class Dome : public Tulip_Thread {
  int me;
public:
  Dome(int me_, char *name) : Tulip_Thread(name) {
    me = me_;
  }

  virtual void run() {

    for (int i = 0; i < 100; i++) {
      mutex.lock();
      cerr << "----------------------------------------\n";
      cerr << Tulip_Context::Me() << " " << (int) getpid() << " Thread " << getName() << " attempts to acquire lock\n";
      cerr << "Thread " << getName() << " is about to yield..\n";
      cerr << "Thread " << getName() << " returns from yield, releases lock\n";
      cerr << "----------------------------------------\n\n\n";
      mutex.unlock();
    }
  }
};




void main(int argc, char** argv)
{
  int cpus = (argc > 1) ? atoi(argv[1]) : 1;
  int debug = (argc > 2) ? atoi(argv[2]) : 1;

  fprintf(stderr,"About to start scheduling..\n");
  double start = Tulip_StartTimer();
  systemContext.addNCpus(cpus-1);
  Dome* dome = new Dome(0, "Dome0");
  Tulip_Context::add(dome);
  dome = new Dome(1, "Dome1");
  Tulip_Context::add(dome);
  systemContext.wait();
  double delta = Tulip_StopTimer(start);


  fprintf(stderr,"Took %f seconds\n", delta);
  fprintf(stderr,"Back in main, about to exit\n");
}
