#include <stdio.h>
#include <stdlib.h>
#include "Tulip_Thread.h"
#include "Tulip_Context.h"
#include "Tulip_Timers.h"



/////////////////////////////////////////////////////////////////////////////
// a simple thread
/////////////////////////////////////////////////////////////////////////////
class athread : public Tulip_Thread {
public:
  athread(char *name) : Tulip_Thread(name) {
  }

  virtual void run() {
    cerr << "Running Thread " <<  getName() << ", priority = " << getPriority() << "\n";
  }
};

/////////////////////////////////////////////////////////////////////////////
// Main routines
/////////////////////////////////////////////////////////////////////////////
void main(int argc, char** argv)
{
  char threadName[30]; 
  int cpus = (argc > 1) ? atoi(argv[1]) : 1;
  int debug = (argc > 2) ? atoi(argv[2]) : 0;

  fprintf(stderr,"About to start scheduling..\n");
  double start = Tulip_StartTimer();
  systemContext.addNCpus(cpus-1);
  for (int i=0; i < 50; i++) {
    sprintf(threadName, "ID %d", i);
    Tulip_ThreadPtr th = new athread(threadName);
    th->setPriority(50-i);
    Tulip_Context::add(th);
  }
  systemContext.wait();
  double delta = Tulip_StopTimer(start);

  fprintf(stderr,"Took %f microseconds\n", delta);
  fprintf(stderr,"Back in main, about to exit\n");
}
