#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "Tulip_Context.h"
#include "Tulip_Timers.h"



class Dome : public Tulip_Thread {
  int me;
public:
  Dome(int me_, char *name) : Tulip_Thread(name) {
    me = me_;
  }

  virtual void run() {
    int me = Tulip_Context::Me();
    for (int i = 0; i < 10; i++) {
      cerr << "Thread " << getName() << " is about to yield..\n";
      Tulip_Context::yield();
      cerr << "Thread " << getName() << " returns from yield\n";
    }
  }
};





void main(int argc, char** argv)
{
  int cpus = (argc > 1) ? atoi(argv[1]) : 1;
  int debug = (argc > 2) ? atoi(argv[2]) : 1;

  fprintf(stderr,"About to start scheduling..\n");
  double start = Tulip_StartTimer();
  systemContext.addNCpus(cpus-1);
  Dome* dome = new Dome(0, "Dome0");
  Tulip_Context::add(dome);
  int me = Tulip_Context::Me();
  dome = new Dome(1, "Dome1");
  Tulip_Context::add(dome);
  dome = new Dome(2, "Dome2");
  Tulip_Context::add(dome);
  dome = new Dome(3, "Dome3");
  Tulip_Context::add(dome);
  dome = new Dome(4, "Dome4");
  Tulip_Context::add(dome);
  dome = new Dome(5, "Dome5");
  Tulip_Context::add(dome);
  dome = new Dome(6, "Dome6");
  Tulip_Context::add(dome);
  systemContext.wait();
  double delta = Tulip_StopTimer(start);

  fprintf(stderr,"Took %f seconds\n", delta);
  fprintf(stderr,"Back in main, about to exit\n");
}
