#include <stream.h>
#include <math.h>

#include "Tulip_Context.h"
#include "Tulip_Timers.h"
#include "Tulip_iolock.h"

#include "Types.h"
#include "Map.h"

extern  DistTab_t    Map ;

#define MAXX    100
#define MAXY    100
typedef struct
                {
                 int x, y ;
                } coor_t ;

typedef coor_t coortab_t [MAXE] ;

void GenerateMap (int seed) 
{

 int tempdist [MAXE] ;
 coortab_t towns ;
 int i, j, k, x ;
 int dx, dy, tmp ;
 int n ;
 
 srand (seed) ;
 n = Map.NrTowns ;
 
 for (i=0; i<n; i++)
  {
   towns [i].x = rand () % MAXX ;
   towns [i].y = rand () % MAXY ;
  }
 
 for (i=0; i<n; i++)
  {
   for (j=0; j<n; j++)
    {
     dx = towns [i].x - towns [j].x ;
     dy = towns [i].y - towns [j].y ;
     tempdist [j] = (int) sqrt ((double) ((dx * dx) + (dy * dy))) ;
    }
 
   for (j=0; j<n; j++)
    {
     tmp = INT_MAX ;
     for (k=0; k<n; k++)
      {
       if (tempdist [k] < tmp)
         {
          tmp = tempdist [k] ;
          x = k ;
         }
      }
     tempdist [x] = INT_MAX ;
     Map.dst [i][j].ToCity = x ;
     Map.dst [i][j].dist = tmp ;
    }
  }
}

void PrintMap ()
{
 int i, j ;
 cout << lock << "distance.NrTowns " << Map.NrTowns << "\n" << flush << unlock;
 
 for (i=0; i<Map.NrTowns; i++)
  {
    cout << lock << "Map.dst [" << i << "]" << flush << unlock ;
      for (j=0; j<Map.NrTowns; j++) {
	cout << lock << "[d:" << Map.dst[i][j].dist << ", to:" << Map.dst[i][j].ToCity << "] " << flush << unlock;
      }
      cout << lock << ";\n\n" << flush << unlock;
  }
}


