/*=======================================================================
 $Log: Tulip_Monitor.h,v $
 Revision 1.1  1998/06/23 00:12:19  ejohnson
 moving directory hpcxx_rts up

 Revision 2.0  1998/05/22 16:54:29  suvas
 New Release (using main as a thread)

 Revision 1.2  1998/05/12 23:14:21  suvas
 This may look like C code, but it is really C++

 Copyright (c) 1998 Los Alamos National Laboratory
 Copyright (c) 1997 University of Colorado, Boulder

 Suvas Vajracharya and Dirk Grunwald

 $Id: Tulip_Monitor.h,v 1.1 1998/06/23 00:12:19 ejohnson Exp $
 $Date: 1998/06/23 00:12:19 $
 $Author: ejohnson $
 ========================================================================*/
#ifndef _Tulip_Monitor_h_
#define _Tulip_Monitor_h_

#ifdef __GNUG__
#  include <bool.h>
#endif

#ifndef TRUE
#undef FALSE
#define TRUE 1
#define FALSE 0
#endif
#include "Tulip_AcquireByUpcall.h"
#include "Tulip_Mutex.h"
//
// A Tulip_Monitor is essentially a wrapping of the Tulip_Mutex class
// with the common acquire/unacquire virtual functions. It is a "safer"
// version of Tulip_Mutex in that it will "yield" if it can not
// acquire the mutex. This isn't significantly more useful than the
// spin wait used in the Tulip_Mutex, but at least this mechanism
// will be fair & correct on a uniprocessor.
//

class Tulip_Monitor : public Tulip_AcquireByUpcall {

protected:
    Tulip_Mutex mutex;

public:

  virtual void acquire() {
    for(;;) {
      if ( mutex.trylock() ) {
	return;
      } else {
	Tulip_Context::yield();
      }
    }
  }

  virtual void release() {
    mutex.unlock();
  }

  virtual bool tryAcquire() {
    if ( mutex.trylock() ) {
      return TRUE;
    } else {
      return FALSE;
    }
  }

private:

  bool acquire_by_upcall(Tulip_Thread *byWho) {
    //
    // Empty
    //
    return false;
  }


};

#endif
