/*=======================================================================
 $Log: Tulip_Runnable.h,v $
 Revision 1.1  1998/06/23 00:12:22  ejohnson
 moving directory hpcxx_rts up

 Revision 2.1  1998/06/15 13:11:15  suvas
 *** empty log message ***

 Revision 1.2  1998/05/12 23:14:23  suvas
 This may look like C code, but it is really C++

 Copyright (c) 1998 Los Alamos National Laboratory
 Copyright (c) 1997 University of Colorado, Boulder

 Suvas Vajracharya and Dirk Grunwald

 $Id: Tulip_Runnable.h,v 1.1 1998/06/23 00:12:22 ejohnson Exp $
 $Date: 1998/06/23 00:12:22 $
 $Author: ejohnson $
 ========================================================================*/
//-*-c++-*-
#ifndef _Tulip_Runnable_h_
#define _Tulip_Runnable_h_

#ifdef __GNUG__
#  pragma interface
#endif

#include "Tulip_Config.h"
#include "Tulip_Location.h"
#include <string.h>

enum Type {ThreadType, IterateType};

enum State {ALIVE, SUSPENDED, STOPPED, NOT_REGISTERED, READY};

class Tulip_Runnable {
  friend class Tulip_Context;
 public:
  State state;

  Tulip_Runnable() {
    cpuAffinity = -1;
    priority = 0;
  }
  virtual Type theType()=0;
  virtual void yield()=0;
  int getPriority(){return priority;};
  void setPriority(int _priority) {priority = _priority;};
  void affinity(Location);
  Location affinity();
 protected:
  virtual void execute()=0;
  virtual void run(){};
 private:
  Location cpuAffinity;
  int priority;
};

typedef Tulip_Runnable *Tulip_RunnablePtr;

inline int
Tulip_Runnable::affinity()
{
    return(cpuAffinity);
}

inline void
Tulip_Runnable::affinity(int new_)
{
    cpuAffinity = new_;
}
#endif
