/*=======================================================================
 $Log: Tulip_SpinFetchAndOp.h,v $
 Revision 1.1  1998/06/23 00:12:26  ejohnson
 moving directory hpcxx_rts up

 Revision 2.0  1998/05/22 16:54:32  suvas
 New Release (using main as a thread)

 Revision 1.2  1998/05/12 23:14:26  suvas
 This may look like C code, but it is really C++

 Copyright (c) 1998 Los Alamos National Laboratory
 Copyright (c) 1997 University of Colorado, Boulder

 Suvas Vajracharya and Dirk Grunwald

 $Id: Tulip_SpinFetchAndOp.h,v 1.1 1998/06/23 00:12:26 ejohnson Exp $
 $Date: 1998/06/23 00:12:26 $
 $Author: ejohnson $
 ========================================================================*/
#ifndef Tulip_FetchAndOp_h
#define Tulip_FetchAndOp_h

#ifdef __GNUG__
#  pragma interface
#endif
//
//	Fetch and op for hardware CPUS
//

#include <Tulip_Mutex.h>
#include <Tulip_Config.h>

class Tulip_FetchAndOp : public Tulip_Mutex {
    VolatileInt	data;
public:
    Tulip_FetchAndOp(int d = 0);
    void set(int);
    int value(){ return(data);};
    int operator  =(int);
    int operator +=(int);
    int operator -=(int);
    int operator |=(int);
    int operator &=(int);
    int operator *=(int);
};



inline void
Tulip_FetchAndOp::set(int d)
{
    data = d ;
}

inline int
Tulip_FetchAndOp::operator=(int d)
{
    lock();
    data = d;
    unlock();
    return( d );
}


inline int
Tulip_FetchAndOp::operator+=(int d)
{
    lock();
    int was = data;
    data += d;
    unlock();
    return(was);
}

inline int
Tulip_FetchAndOp::operator-=(int d)
{
    lock();
    int was = data;
    data -= d;
    unlock();
    return(was);
}

inline int
Tulip_FetchAndOp::operator|=(int d)
{
    lock();
    int was = data;
    data |= d;
    unlock();
    return(was);
}

inline int
Tulip_FetchAndOp::operator&=(int d)
{
    lock();
    int was = data;
    data &= d;
    unlock();
    return(was);
}

inline int
Tulip_FetchAndOp::operator*=(int d)
{
    lock();
    int was = data;
    data *= d;
    unlock();
    return(was);
}

#endif /* Tulip_FetchAndOp_h */
