
/*=======================================================================
 $Log: Context-lock.s,v $
 Revision 1.1  1998/06/23 00:12:50  ejohnson
 moving directory hpcxx_rts up

 Revision 2.0  1998/05/22 16:54:45  suvas
 New Release (using main as a thread)

 Revision 1.2  1998/05/12 23:15:06  suvas
 This may look like C code, but it is really C++

 Copyright (c) 1998 Los Alamos National Laboratory
 Copyright (c) 1997 University of Colorado, Boulder

 Suvas Vajracharya and Dirk Grunwald

 $Id: Context-lock.s,v 1.1 1998/06/23 00:12:50 ejohnson Exp $
 $Date: 1998/06/23 00:12:50 $
 $Author: ejohnson $
 ========================================================================*/	
#include <asm.h>
#include <regdef.h>
/*
 * On entry:
 *   $A0 = argument for routine we transfer to (moved to $a0)
 *   $A1 = address for routine we're going to (moved to $ra)
 *
 * On exit, we jump to specified routine.
 *   $A0 = argument
 *
 *
 */
	LEAF(Tulip_trampoline)
	mov s0,a0
	mov s1,ra
	mov s1,$27
	jmp zero, (ra), 1
	END(Tulip_trampoline)

/*
 * A spin lock function using the LL/STLC mechanism. This
 * is a test-and-test-and-set lock.
 *
 * We assume the lock is a longword, with the address passed
 * via a0. We assume that the 'winning content' of the spin
 * lock is passed in a1. This winning content can not be zero.
 *
 */
	LEAF(Tulip_spinlock)
/* 	bis zero,1,a1 */

$448:
	ldl_l	t1,0(a0)
	mov	a1,t2
	bne	t1,$451
	stl_c	t2,0(a0)
	beq	t2,$451		/* STL_C will set T1 to zero if conflict */
	ret zero,(ra),1
$451:
	ldl t0,0(a0)
	beq t0,$448
	br	zero,$451
	END(Tulip_spinlock)

/*
 * as above, but don't loop waiting for lock to be free.
 * return ZERO if lock is not acquires, ONE if it is acquired
 */

	LEAF(Tulip_spintrylock)

	ldl_l	t1,0(a0)
	mov	a1,t2
	bne	t1,$500
	stl_c	t2,0(a0)
	beq	t2,$500		/* STL_C will set T1 to zero if conflict */
	bis	zero,1,v0	/* success, return 1 */
	ret zero,(ra),1
$500:
	mov	zero,v0		/* failure, return 0 */
	ret zero,(ra),1
	END(Tulip_spintrylock)
