/*=======================================================================
 $Log: Context.s,v $
 Revision 1.1  1998/06/23 00:12:53  ejohnson
 moving directory hpcxx_rts up

 Revision 2.0  1998/05/22 16:54:46  suvas
 New Release (using main as a thread)

 Revision 1.2  1998/05/12 23:15:08  suvas
 This may look like C code, but it is really C++

 Copyright (c) 1998 Los Alamos National Laboratory
 Copyright (c) 1997 University of Colorado, Boulder

 Suvas Vajracharya and Dirk Grunwald

 $Id: Context.s,v 1.1 1998/06/23 00:12:53 ejohnson Exp $
 $Date: 1998/06/23 00:12:53 $
 $Author: ejohnson $
 ========================================================================*/
#include <asm.h>
#include <regdef.h>

/*
 * the following describes the layout
 * of the Tulip_NonPremptiveContext
 */
#define NPC_resume	0
#define NPC_R9		1
#define NPC_R10		2
#define NPC_R11		3

#define NPC_R12		4
#define NPC_R13		5
#define NPC_R14		6
#define NPC_R15		7

#define NPC_R26		8
#define NPC_R29		9
#define NPC_R30		10
#define NPC_F2		11

#define NPC_F3		12
#define NPC_F4		13
#define NPC_F5		14
#define NPC_F6		15

#define NPC_F7		16
#define NPC_F8		17
#define NPC_F9		18

	.set noat
	.set noreorder
	.comm	a 8
	.comm	b 8
	.comm	c 8
	.comm	d 8
	.text
	.align 4
	.loc 1 5
	LEAF(Tulip_SaveNP)
/*
 * On entry:
 *   $A0 = resurrect
 *   $A1 = hook body
 *   $A2 = hook data
 *   $A3 = saveto
 *
 * On exit, we jump to resurrect -> resume with
 *   $A0 = ressurect
 *   $A1 = hook body
 *   $A2 = hook data
 */
#define SAVE(X,Y)	stq X,Y *8(a3)
#define SAVEF(X,Y)	stt X,Y *8(a3)

	SAVE($9,NPC_R9)
	SAVE($10,NPC_R10)
	SAVE($11,NPC_R11)
	SAVE($12,NPC_R12)
	SAVE($13,NPC_R13)
	SAVE($14,NPC_R14)
	SAVE($15,NPC_R15)

	SAVE($26,NPC_R26)
	SAVE($29,NPC_R29)
	SAVE($30,NPC_R30)

	SAVEF($f2,NPC_F2)
	SAVEF($f3,NPC_F3)
	SAVEF($f4,NPC_F4)
	SAVEF($f5,NPC_F5)
	SAVEF($f6,NPC_F6)
	SAVEF($f7,NPC_F7)
	SAVEF($f8,NPC_F8)
	SAVEF($f9,NPC_F9)

	ldq	ra, 0(a0)
	jmp	zero, (ra), 1
	END(Tulip_SaveNP)

	LEAF(Tulip_RestoreNP)
/*
 * On entry:
 *   $A0 = resurrect
 *   $A1 = hook body
 *   $A2 = hook argument
 *
 * On exit, we jump to resurrect -> resume with
 *   $A0 = ressurect
 *   $A1 = hook body
 *   $A2 = hook argument
 */
#define LOAD(X,Y)	ldq X,Y *8(a0)
#define LOADF(X,Y)	ldt X,Y *8(a0)

	/*
	 * For the path of no hook routine, we'll
	 * generate loads in the following order
	 *
	 *	64	72	80	88
	 *	0	8	16	24
	 *	32	40	48	56
	 *	96	104	112	120
	 *	128	136	144	152
	 *
	 * Our loads provide a little prefetching - we'll
	 * first fetch 80 (needed for the hook) and then
	 * fetch the next line each time
	 */
	

	LOAD(sp,NPC_R30)
/*
 * Now, call the 'resumption hook' if there is one (in A1),
 * moving argument into argument register
 */
	beq	a1,F2
	mov	a0,s0	/* save the base pointer for saving .. */
	mov	a1,pv
	mov	a2, a0
	jsr	ra,(pv)
	mov	s0,a0 /* restore argument pointer for state restore..*/
F2:
	/*
	* This order is to minimize misses
	*/
	/*
	 * 80 (above), 8, 64, 72, 88
	 */
	LOAD($9,NPC_R9)
	LOAD(ra,NPC_R26)
	LOAD(gp,NPC_R29)
	LOADF($f2,NPC_F2)

	/* 8 (above), 32, 16, 24 */

	LOAD($12,NPC_R12)
	LOAD($10,NPC_R10)
	LOAD($11,NPC_R11)


	/*
	 * 32 (above), 96, 30, 48, 56
	 */

	LOADF($f3,NPC_F3)
	LOAD($13,NPC_R13)
	LOAD($14,NPC_R14)
	LOAD($15,NPC_R15)

	/*
	 * 96 (above), 128, 104, 112, 120
	 */
	LOADF($f4,NPC_F4)
	LOADF($f7,NPC_F7)
	LOADF($f5,NPC_F5)
	LOADF($f6,NPC_F6)

	/*
	 * 128 (above), 136, 144
	 */
	LOADF($f8,NPC_F8)
	LOADF($f9,NPC_F9)
	/*
	 * Now, jump to return
	 */
	jmp	zero, (ra), 1
	END(Tulip_RestoreNP)













