/*=======================================================================
 $Log: Tulip_Helpers.h,v $
 Revision 1.1  1998/06/23 00:12:58  ejohnson
 moving directory hpcxx_rts up

 Revision 2.0  1998/05/22 16:54:48  suvas
 New Release (using main as a thread)

 Revision 1.3  1998/05/15 22:53:19  suvas
 *** empty log message ***

 Revision 1.2  1998/05/12 23:15:10  suvas
 This may look like C code, but it is really C++

 Copyright (c) 1998 Los Alamos National Laboratory
 Copyright (c) 1997 University of Colorado, Boulder

 Suvas Vajracharya and Dirk Grunwald

 $Id: Tulip_Helpers.h,v 1.1 1998/06/23 00:12:58 ejohnson Exp $
 $Date: 1998/06/23 00:12:58 $
 $Author: ejohnson $
 ========================================================================*/
#ifndef _Tulip_Helpers_h_
#define _Tulip_Helpers_h_
#include <iostream.h>
#include <Tulip_Config.h>
#include <vector>
#include <stack>
#include <list>
#include <unistd.h>
#include <pthread.h>
#include "CUT_BinHeap.h"

inline int whoAmI() {
  return ((long) pthread_self());
}
typedef greater_equal<int> Higher;
template <class T>
class LockedPriorityQueue  : public CUT_BinHeap<int, T, Higher>
{
 public:
  Tulip_Mutex qLock;
  void addUnLocked(T object) {
    insert(object->getPriority(),object);
  }
  void add(T object) {
    qLock.lock();
    insert(object->getPriority(),object);
    qLock.unlock();
  }

  T remove(){
    T object = NULL;
    qLock.lock();
    if (!empty()) {
      object = top();
      deq();
    }
    qLock.unlock();
    return object;
  }
  T removeUnLocked(){
    T object = NULL;
    if (!empty()) {
      object = top();
      deq();
    }
    return object;
  }
};

int Tulip_Fork(void *fArgs, voidPtrFuncP func);
class Tulip_Context;
typedef Tulip_Context * Tulip_ContextPtr;

class Tulip_PrivateContext {
  Tulip_ContextPtr contextP;
public:
  Tulip_PrivateContext();
  Tulip_ContextPtr operator->();
  void operator=(const Tulip_ContextPtr& context);
};


class Tulip_ForkArgs {
public:
  int id;
  int numcpus;
};

#endif
