/*=======================================================================*/
/* Revision 1.2  1998/05/12 23:15:21  suvas                              */
/* This may look like C code, but it is really C++                       */

/* Copyright (c) 1998 Los Alamos National Laboratory			 */
/* Copyright (c) 1997 University of Colorado, Boulder			 */
/* Suvas Vajracharya and Dirk Grunwald					 */
	
/* $Id: Context-lock.s,v 1.1 1998/06/23 00:13:07 ejohnson Exp $		 */
/* $Date: 1998/06/23 00:13:07 $						 */
/* $Author: ejohnson $							 */
/* ======================================================================*/
	
/* A spin lock function. This */
/* is a test-and-set lock. */

/* INPUT:		
/* 8(ebp) - address of lock, a long word */
/* 12(ebp) - winning content, assumed to have a value of 1 */

/* OUTPUT:		
	.text
	.align 4
.globl Tulip_spinlock
.type  Tulip_spinlock__Fii,@function
Tulip_spinlock:
	pushl	%ebp
	movl	%esp,%ebp
	mov	8(%ebp),  %edx
	mov	12(%ebp), %ecx

.LTRY:	cmpl    $0, 0(%edx)        /* test without locking first */
	jne	.LTRY

	xchg	%ecx, 0(%edx)	   /* if initial value=0, success */
	cmpl	$0, %ecx
	jne	.LTRY
	leave
	ret
	 

/* as above, but don't loop waiting for lock to be free. */
/* return ZERO if lock is not acquires, ONE if it is acquired */

	.align 4
.globl Tulip_spintrylock
.type  Tulip_spintrylock,@function
Tulip_spintrylock:
	pushl	%ebp
	movl	%esp,%ebp
	mov	8(%ebp),  %edx
	mov	12(%ebp), %ecx
		
	xchg	%ecx, 0(%edx)	   /* if initial value=0, success */
	movl	%ecx, %eax
	neg	%eax
	leave	
	ret


