/*=======================================================================*/
/* Revision 1.2  1998/05/12 23:15:21  suvas                              */
/* This may look like C code, but it is really C++                       */

/* Copyright (c) 1998 Los Alamos National Laboratory			 */
/* Copyright (c) 1997 University of Colorado, Boulder			 */

/* Suvas Vajracharya and Dirk Grunwald					 */

/* $Id: Context.s,v 1.1 1998/06/23 00:13:10 ejohnson Exp $			 */
/* $Date: 1998/06/23 00:13:10 $
/* $Author: ejohnson $
/* ======================================================================*/
	
#include <asm.h>
#include <regdef.h>

/* the following describes the layout */
/*   of the Tulip_NonPremptiveContext */
	
NPC_resume =	0
NPC_R1	=	(1*4)    /* EAX */
NPC_R2	=	(2*4)    /* EBX */
NPC_R3	=	(3*4)    /* ECX, used as address for routine */
NPC_R4	=	(4*4)    /* EDX, used as return address */
NPC_R5	=	(5*4)    /* EBP */
NPC_R6	=	(6*4)    /* ESI */
NPC_R7	=	(7*4)    /* EDI */
NPC_R8	=	(8*4)    /* ESP */

		.text	
	.align	4
	.globl	Tulip_SaveNP
	.type  Tulip_SaveNP_Fiiii,@function
	
Tulip_SaveNP:
	
/*  On entry: */
/*    8(%ebp) = resurrect context*/
/*   12(%ebp) = hook body */
/*   16(%ebp) = hook data */
/*   20(%ebp) = saveto */

/* On exit, we jump to resurrect -> resume with */
/*    8(%ebp) = resurrect */
/*   12(%ebp) = hook body */
/*   16(%ebp) = hook data */

	pushl %ebp
	movl  %esp,%ebp			/* setup frame for this proc */
	pushl %ebx			/* save ebx, we need to use as temp. */
	movl  20(%ebp), %ebx            /* this is where we save the state */
	
	movl %eax,NPC_R1(%ebx)		/* save registers */ 
	movl %ecx,NPC_R3(%ebx)
	movl %edx,NPC_R4(%ebx)
	movl %esi,NPC_R6(%ebx)
	movl %edi,NPC_R7(%ebx)
	
	popl NPC_R2(%ebx)		/* save ebx */
	popl NPC_R5(%ebx)		/* save ebp */
	movl %ebp, %ecx			/* save original stack pointer,esp */
	addl $4, %ecx
	movl %ecx,NPC_R8(%ebx)
	
	movl  8(%ebp),%ebx		/* jump to the resurrect routine*/
	jmp NPC_resume(%ebx) 

	.align	4
	.globl	Tulip_RestoreNP
	.type  Tulip_RestoreNP_Fiii,@function	

	/* On entry: */
/*   8(%ebp) = resurrect context*/
/*   12(%ebp) = hook body */
/*   16(%ebp) = hook argument */

/* On exit, we jump to resurrect -> resume with */
/*   8(%ebp) = resurrect */
/*   12(%ebp) = hook body */
/*   16(%ebp) = hook argument */
	
Tulip_RestoreNP:
	movl 8(%ebp), %ebx	/* get param 1, resurrect */
	movl 12(%ebp), %ecx	/* get param 2, hook body */
	
	movl NPC_R8(%ebx), %esp /* restore stack pointer for new context */

/* Now, call the 'resumption hook' if there is one (in A1), */
/* moving argument into argument register */

	cmpl    $0, %ecx        /* check if param 2 is null */
	je	.L2
	
	movl    16(%ebp), %eax	/* get param 3, hook argument */
	movl	%esp,%ebp	/* set up to call the hook */
	pushl   %eax		/* param 3 will be param 1 for the hook routine */
	
	call	%ecx		/* resumption hook non-null, call it */
	addl    $4,%esp

.L2:

	movl NPC_R1(%ebx), %eax
	movl NPC_R3(%ebx), %ecx
	movl NPC_R4(%ebx), %edx
	movl NPC_R5(%ebx), %ebp
	movl NPC_R6(%ebx), %esi 
	movl NPC_R7(%ebx), %edi 
	movl NPC_R8(%ebx), %esp /* restore stack pointer for new context */
	
	movl NPC_R2(%ebx),%ebx
.L3:	ret

	.align	4
	.globl	Tulip_trampoline
	.type  Tulip_trampoline,@function


/* On entry: */
/*    %eax = argument for routine we transfer to  */
/*    %ecx = address for routine we're going to  */
/* On exit, we jump to specified routine. */

Tulip_trampoline:	
	pushl %ebp
	movl %esp,%ebp
	pushl %eax	/* argument to routine we are transfering to */
	call  %ecx	/* transfer control */
	addl $4,%esp	/* pop the parameter */
	leave
	ret





