/*=======================================================================
 $Log: ContextC.C,v $
 Revision 1.1  1998/06/23 00:13:12  ejohnson
 moving directory hpcxx_rts up

 Revision 2.0  1998/05/22 16:54:56  suvas
 New Release (using main as a thread)

 Revision 1.2  1998/05/12 23:15:22  suvas
 This may look like C code, but it is really C++

 Copyright (c) 1998 Los Alamos National Laboratory
 Copyright (c) 1997 University of Colorado, Boulder

 Suvas Vajracharya and Dirk Grunwald

 $Id: ContextC.C,v 1.1 1998/06/23 00:13:12 ejohnson Exp $
 $Date: 1998/06/23 00:13:12 $
 $Author: ejohnson $
 ========================================================================*/
#include "Context.h"
#include <stdio.h>
#include <iostream.h>
extern "C" {
void Tulip_trampoline();
}
void
Tulip_InitNP(Tulip_NonPremptiveContext *context,
	     Tulip_U64 *stack,
	     void *routine,
	     void *argument)
{
  
  /*
    *	To build a thread, we return to the first address of startOff,
    *	which will use the current FP & SP to build a local context,
    *	and then call the user main.
    *
    *	startOff needs to have a valid frame. The return address for this
    *	frame is NULL, since we never exit procedure startOff.
    */

  char *pch = (char *)&stack[0];
  *pch++ = 'T'; *pch = '\0';
  stack[-1] = 0;
  stack[-2] = (Tulip_U64) &stack[-1];
  stack[-3] = (Tulip_U64) &stack[-2];
  stack[-4] = (Tulip_U64) Tulip_trampoline; /* return address */

  context -> R1 =  (Tulip_U64) argument;        /* eax */
  context -> R3 = (Tulip_U64) routine;          /* ecx */
  context -> R8 = (Tulip_U64) &stack[-4];       /* esp */
  Tulip_SetNonPremptiveResume(context);

}
void 
Tulip_NonPremptiveContext::print_state()
{
  cerr << "EAX = " << R1 << "\n";
  cerr << "EBX = " << R2 << "\n";
  cerr << "ECX = " << R3 << "\n";
  cerr << "EDX = " << R4 << "\n";
  cerr << "EBP = " << R5 << "\n";
  cerr << "ESI = " << R6 << "\n";
  cerr << "EDI = " << R7 << "\n";
  cerr << "ESP = " << R8 << "\n";
  cerr << "\n" << flush;

}

extern void
Tulip_SetResume(Tulip_NonPremptiveContext *context,
		void * routine)
{
  context -> resume = (Tulip_voidfuncptr)routine;
}
