/*=======================================================================
 $Log: Tulip_Helpers.C,v $
 Revision 1.1  1998/06/23 00:13:13  ejohnson
 moving directory hpcxx_rts up

 Revision 2.0  1998/05/22 16:54:56  suvas
 New Release (using main as a thread)

 Revision 1.2  1998/05/12 23:15:23  suvas
 This may look like C code, but it is really C++

 Copyright (c) 1998 Los Alamos National Laboratory
 Copyright (c) 1997 University of Colorado, Boulder

 Suvas Vajracharya and Dirk Grunwald

 $Id: Tulip_Helpers.C,v 1.1 1998/06/23 00:13:13 ejohnson Exp $
 $Date: 1998/06/23 00:13:13 $
 $Author: ejohnson $
 ========================================================================*/
#ifdef __GNUG__
#  pragma implementation
#endif
#include <Tulip_Helpers.h>
#include <Tulip_Context.h>
#include <assert.h>
#include <stdlib.h>


Tulip_ContextPtr Tulip_PrivateContext::operator->(){
  int pid = getpid();
  int i;
  for (i=0; i < Tulip_Context::numcpus; i++) {
    if (Tulip_Context::Contexts[i] != NULL)
      if (pid == Tulip_Context::Contexts[i]->pid)
	break;
  }
  return Tulip_Context::Contexts[i];
}
void Tulip_PrivateContext::operator=(const Tulip_ContextPtr& context){
}

#define PAGE_SIZE  (sysconf(_SC_PAGE_SIZE))
/* Size of the thread manager stack. The "- 32" avoids 
   wasting space with some malloc() implementations. */

#define PROCESS_STACK_SIZE (3 * PAGE_SIZE - 32)

int Tulip_Fork(void *fArgs, voidPtrFuncP func){
  void * stack = malloc(PROCESS_STACK_SIZE);
  assert(stack != NULL); 
  int ret = __clone(func, 
		    (void **)(stack+PROCESS_STACK_SIZE),
		    CLONE_VM | CLONE_FS | CLONE_FILES | CLONE_SIGHAND,
		    (void *)fArgs);
  assert(ret != -1);
  if (Tulip_Context::debug)
    cerr << "pthread created \n" << flush;
}


Tulip_PrivateContext::Tulip_PrivateContext()
{

}




