/*=======================================================================
 $Log: Tulip_Helpers.h,v $
 Revision 1.1  1998/06/23 00:13:15  ejohnson
 moving directory hpcxx_rts up

 Revision 2.0  1998/05/22 16:54:57  suvas
 New Release (using main as a thread)

 Revision 1.4  1998/05/15 22:53:23  suvas
 *** empty log message ***

 Revision 1.3  1998/05/14 00:08:11  suvas
 Revision 1.2  1998/05/12 23:15:24  suvas
 This may look like C code, but it is really C++

 Copyright (c) 1998 Los Alamos National Laboratory
 Copyright (c) 1997 University of Colorado, Boulder

 Suvas Vajracharya and Dirk Grunwald

 $Id: Tulip_Helpers.h,v 1.1 1998/06/23 00:13:15 ejohnson Exp $
 $Date: 1998/06/23 00:13:15 $
 $Author: ejohnson $
 ========================================================================*/

#ifndef _Tulip_Helpers_h_
#define _Tulip_Helpers_h_
#ifdef __GNUG__
#  pragma interface
#endif
#include <unistd.h>
#include <Tulip_Config.h>
#include <iostream.h>
#include <vector>
#include <stack>
#include <queue>
#include <list>

inline int whoAmI() {
  return ((int) getpid());
}
extern "C" {
#include <sched.h>
#include <unistd.h>
}
template <class T>
class Higher {
public:
  int operator() (const T &x, const T &y)
  {
     return (y->getPriority() > x->getPriority());
  }
};

template <class T>
class LockedPriorityQueue: public priority_queue<vector<T>,Higher<T> > {
 public:
  Tulip_Mutex qLock;
  void addUnLocked(T object) {
    push(object);
  }
  void add(T object) {
    qLock.lock();
    push(object);
    qLock.unlock();
  }

  T remove(){
    T object = NULL;
    qLock.lock();
    if (!empty()) {
      object = top();
      pop();
    }
    qLock.unlock();
    return object;
  }
  T removeUnLocked(){
    T object = NULL;
    if (!empty()) {
      object = top();
      pop();
    }
    return object;
  }
};
int Tulip_Fork(void *fArgs, voidPtrFuncP func);
class Tulip_Context;
typedef Tulip_Context * Tulip_ContextPtr;

class Tulip_PrivateContext {
  Tulip_ContextPtr contextP;
public:
  Tulip_PrivateContext();
  Tulip_ContextPtr operator->();
  void operator=(const Tulip_ContextPtr& context);
};


class Tulip_ForkArgs {
public:
  int id;
  int numcpus;
};

#endif
