/*=======================================================================
 $Log: Context-lock.s,v $
 Revision 1.1  1998/06/23 00:13:21  ejohnson
 moving directory hpcxx_rts up

 Revision 2.0  1998/05/22 16:55:02  suvas
 New Release (using main as a thread)

 Revision 1.2  1998/05/12 23:15:40  suvas
 This may look like C code, but it is really C++

 Copyright (c) 1998 Los Alamos National Laboratory
 Copyright (c) 1997 University of Colorado, Boulder

 Suvas Vajracharya and Dirk Grunwald

 $Id: Context-lock.s,v 1.1 1998/06/23 00:13:21 ejohnson Exp $
 $Date: 1998/06/23 00:13:21 $
 $Author: ejohnson $
 ========================================================================*/
#include <asm.h>
#include <regdef.h>
/*
 A spin lock function using the LL/SC mechanism. This
 is a test-and-test-and-set lock.

 We assume the lock is a longword, with the address passed
 via a0. We assume that the 'winning content' of the spin
 lock is passed in a1. This winning content must not be  zero.

*/
	

	LEAF(Tulip_spinlock)

$448:

	lld	t1,0(a0)	/* load counter from param 1 */
	move	t2,a1		/* get second param, the "winning content"  */
	bne	t1,0,$451
	scd	t2,0(a0)
	beq	t2,0, $451	/* SCD will set T1 to zero if conflict */
	jr	ra


$451:
	ldl	t0,0(a0)
	beq	t0,0, $448
	jr	$451

	END(Tulip_spinlock)
	
/*
 as above, but don't loop waiting for lock to be free.
 return ZERO if lock is not acquires, ONE if it is acquired
*/ 

	LEAF(Tulip_spintrylock)
	lld	t1,0(a0)
	move	t2,a1
	bne	t1,0,$500
	scd	t2,0(a0)
	beq	t2,0,$500	/* SCD will set T1 to zero if conflict */
	or	v0,zero,1	/* success, return 1 */
	jr	ra

$500:
	move	v0,zero		/* failure, return 0  */
	jr	ra

	END(Tulip_spintrylock)


