/*=======================================================================
 $Log: Context.s,v $
 Revision 1.1  1998/06/23 00:13:24  ejohnson
 moving directory hpcxx_rts up

 Revision 2.0  1998/05/22 16:55:03  suvas
 New Release (using main as a thread)

 Revision 1.2  1998/05/12 23:15:42  suvas
 This may look like C code, but it is really C++

 Copyright (c) 1998 Los Alamos National Laboratory
 Copyright (c) 1997 University of Colorado, Boulder

 Suvas Vajracharya and Dirk Grunwald

 $Id: Context.s,v 1.1 1998/06/23 00:13:24 ejohnson Exp $
 $Date: 1998/06/23 00:13:24 $
 $Author: ejohnson $
 ========================================================================*/
#include <asm.h>
#include <regdef.h>

/* the following describes the layout
   of the Tulip_NonPremptiveContext
*/
#define NPC_resume	0
#define NPC_R16		(1*8)	/* S0 */
#define NPC_R17		(2*8)
#define NPC_R18		(3*8)  
#define NPC_R19		(4*8)
#define NPC_R20		(5*8)
#define NPC_R21		(6*8)   /* ... */
#define NPC_R22		(7*8)
#define NPC_R23		(8*8)
#define NPC_R24		(9*8)   /* S8 */
#define NPC_R28		(10*8)  /* GP */ 	
#define NPC_R29		(11*8)  /* SP */
#define NPC_R30		(12*8)  /* FP */
#define NPC_R31		(13*8)  /* RA */

#define NPC_F20		(14*8)
#define NPC_F22		(15*8)
#define NPC_F24		(16*8)
#define NPC_F26		(17*8)
#define NPC_F28		(18*8)
#define NPC_F30		(19*8)


		.text	
	.align	2
	.globl	bogus2
	.loc	2 65
	.ent	bogus2
bogus2:	
	move $25, a0
	move a0, $0
	jalr $25
	jr ra	
	.end	bogus2

	
	LEAF(Tulip_SaveNP)
/*
 On entry:
   $A0 = resurrect
   $A1 = hook body
   $A2 = hook data
   $A3 = saveto

 On exit, we jump to resurrect -> resume with
   $A0 = ressurect
   $A1 = hook body
   $A2 = hook data
*/

#define SAVEF(X,Y)	s.d  X,Y *8(a3)

	REG_S $16,NPC_R16(a3)
	REG_S $17,NPC_R17(a3)
	REG_S $18,NPC_R18(a3)
	REG_S $19,NPC_R19(a3)	
	REG_S $20,NPC_R20(a3)
	REG_S $21,NPC_R21(a3)
	REG_S $22,NPC_R22(a3)
	REG_S $23,NPC_R23(a3)
	REG_S $24,NPC_R24(a3)
	
	REG_S $28,NPC_R28(a3)	
	REG_S $29,NPC_R29(a3)
	REG_S $30,NPC_R30(a3)					
	REG_S $31,NPC_R31(a3)				
	
	s.d $f20,NPC_F20(a3)
	s.d $f22,NPC_F22(a3)
	s.d $f24,NPC_F24(a3)
	s.d $f26,NPC_F26(a3)
	s.d $f28,NPC_F28(a3)
	s.d $f30,NPC_F30(a3)

	REG_L	ra, 0(a0)
	jr	ra
	END(Tulip_SaveNP)

	LEAF(Tulip_RestoreNP)
/*
 On entry:
   $A0 = resurrect
   $A1 = hook body
   $A2 = hook argument

 On exit, we jump to resurrect -> resume with
   $A0 = ressurect
   $A1 = hook body
   $A2 = hook argument
*/
/*	
#define LOAD(X,Y)	REG_L X,Y*8(a0)
#define LOADF(X,Y)	l.d X,Y*8(a0)
*/


	REG_L sp,NPC_R29(a0)
/*
 Now, call the 'resumption hook' if there is one (in A1),
 moving argument into argument register
*/

	beq	a1,0,F2
	move	s0,a0	/* save the base pointer for saving .. */
	move	t9,a1
	move	a0,a2
	jalr	t9
	move	a0,s0  /* restore argument pointer for state restore.. */

F2:
/*
	 This order is to minimize misses
	
	
	 80 (above), 8, 64, 72, 88
	*/
	 
	REG_L $16,NPC_R16(a0) 
	REG_L ra,NPC_R31(a0)
	/*
	REG_L gp,NPC_R28(a0)
	*/
	REG_L fp,NPC_R30(a0)

	l.d $f20,NPC_F20(a0)

	/* 8 (above), 32, 16, 24  */

	REG_L $19,NPC_R19(a0)
	REG_L $18,NPC_R18(a0)
	REG_L $17,NPC_R17(a0)


	/*
	  32 (above), 96, 30, 48, 56
	 */

	l.d $f22,NPC_F22(a0)
	REG_L $20,NPC_R20(a0)
	REG_L $21,NPC_R21(a0)
	REG_L $22,NPC_R22(a0)


	/*
	  96 (above), 128, 104, 112, 120
	 */
	
	l.d $f24,NPC_F24(a0)
	l.d $f26,NPC_F26(a0)
	l.d $f28,NPC_F28(a0)
	l.d $f30,NPC_F30(a0)

	REG_L $23,NPC_R23(a0)
	REG_L $24,NPC_R24(a0)	
	/*
	  128 (above), 136, 144
	*/
	
       /* Now, jump to return */
	jr	ra
	END(Tulip_RestoreNP)

/*
 On entry:
   $A0 = argument for routine we transfer to (moved to $a0)
   $A1 = address for routine we're going to (moved to $ra)

 On exit, we jump to specified routine.
   $A0 = argument

*/
	LEAF(Tulip_trampoline)
	move a0,s0
	move ra,s1
	move t9,s1
	jr  ra
	END(Tulip_trampoline)



