/*=======================================================================
 $Log: Tulip_Helpers.h,v $
 Revision 1.1  1998/06/23 00:13:28  ejohnson
 moving directory hpcxx_rts up

 Revision 2.1  1998/06/15 13:11:22  suvas
 *** empty log message ***

 Revision 2.0  1998/05/22 16:55:05  suvas
 New Release (using main as a thread)

 Revision 1.2  1998/05/12 23:15:45  suvas
 This may look like C code, but it is really C++

 Copyright (c) 1998 Los Alamos National Laboratory
 Copyright (c) 1997 University of Colorado, Boulder

 Suvas Vajracharya and Dirk Grunwald

 $Id: Tulip_Helpers.h,v 1.1 1998/06/23 00:13:28 ejohnson Exp $
 $Date: 1998/06/23 00:13:28 $
 $Author: ejohnson $
 ========================================================================*/
#ifdef __GNUG__
#pragma interface
#endif 

#ifndef _Tulip_Helpers_h_
#define _Tulip_Helpers_h_
#include <unistd.h>
#include <sys/types.h>
#include <sys/prctl.h>
#include <sys/wait.h>
#include <Tulip_Config.h>
#include <vector.h>
#include <deque.h>
#include <stack.h>
#include <function.h>
#include <list.h>
#include <Tulip_iolock.h>

inline int whoAmI() {
  return ((int) getpid());
}
template <class T>
class Higher {
public:
  int operator() (const T &x, const T &y)
  {
     return (y->getPriority() > x->getPriority());
  }
};
template <class T>
class LockedPriorityQueue: public priority_queue<T,vector<T>,Higher<T> > {
 public:
  Tulip_Mutex qLock;
  void addUnLocked(T object) {
    push(object);
    Tulip_Context::GlobalEventsCounter+=1;
  }
  void add(T object) {
    qLock.lock();
    push(object);
    Tulip_Context::GlobalEventsCounter+=1;
    qLock.unlock();
  }

  T remove(){
    T object = NULL;
    qLock.lock();
    if (!empty()) {
      object = top();
      pop();
      Tulip_Context::GlobalEventsCounter-=1;
    }
    qLock.unlock();
    return object;
  }
  T removeUnLocked(){
    T object = NULL;
    if (!empty()) {
      object = top();
      pop();
      Tulip_Context::GlobalEventsCounter-=1;
    }
    return object;
  }
};

class Tulip_Context;
typedef Tulip_Context *Tulip_ContextPtr;

class Tulip_PrivateContext {
public:
  Tulip_PrivateContext() {
  //  *((Tulip_ContextPtr *)PRDA->unused) = NULL;
  }
  Tulip_ContextPtr operator->(){
    return *((Tulip_ContextPtr *)PRDA->unused);
  }
  Tulip_ContextPtr getContext(){
    return *((Tulip_ContextPtr *)PRDA->unused);
  }
  void operator=(const Tulip_ContextPtr& context){
    *((Tulip_ContextPtr *)PRDA->unused) = context;
  }
};

typedef Tulip_Context *Tulip_ContextPtr;

class Tulip_ForkArgs {
public:
  int id;
  int numcpus;
};

inline int Tulip_Fork(void *fArgs,voidPtrFuncP func) {
 return sproc(func, PR_SADDR,fArgs);
}
#endif

