#include <iostream.h>
#include "CUT_TLBFlex.h"
#include <stdlib.h>
#include <random.h>

typedef CUT_TLBFlex<8> TlbType;

const int verbose = 0;
const int debug = 0;

int
main()
{
  //
  //
  long howmany = 100000;
  cout << "Insert " << howmany << " TLB references into a small 2-way associative TLB\n";

  TlbType tlb(128,0);

  for (int i = 0; i < howmany ; i++) {
    unsigned long addr = ::random() % 0x7fff;

    TlbType::decoded decoded;

    tlb.map_addr(addr, decoded);

    if ( verbose ) {
      cout << "Reference address " << hex << addr << dec;
      cout << " as bank " << decoded.bank_index << ", page " << decoded.page_offset << endl;
    }

    if ( tlb.check_for_hit(decoded) ) {
      if ( debug ) {
	cout << "MISS: ";
      }
      tlb.update_tlb(decoded);
    } else {
      if ( debug ) {
	cout << "HIT: ";

      }
    }
    if ( debug ) {
      cout << addr << "(" << decoded.page_offset << ")" << endl;
    }
  }
    
  tlb.digestable_report(cout,"demo");
}

