/*=======================================================================
 $Log: Tulip_SpinBarrier.C,v $
 Revision 1.1  1998/06/23 00:18:16  ejohnson
 moving directory hpcxx_rts up

 Revision 2.0  1998/05/22 16:57:33  suvas
 New Release (using main as a thread)

 Revision 1.2  1998/05/12 23:15:59  suvas
 This may look like C code, but it is really C++

 Copyright (c) 1998 Los Alamos National Laboratory
 Copyright (c) 1997 University of Colorado, Boulder

 Suvas Vajracharya and Dirk Grunwald

 $Id: Tulip_SpinBarrier.C,v 1.1 1998/06/23 00:18:16 ejohnson Exp $
 $Date: 1998/06/23 00:18:16 $
 $Author: ejohnson $
 ========================================================================*/

#ifdef __GNUG__
#  pragma implementation
#endif

#include <stream.h>
#include "Tulip_SpinBarrier.h"
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <Tulip_iolock.h>
extern "C" {
  pid_t getpid(void);
}

Tulip_SpinBarrier::Tulip_SpinBarrier( int h, int l, int m )
{
    pHeight = h;
    pLoops = l;
    pMaxLoops = m;
    pCount = 0;
}
int Tulip_SpinBarrier::rendezvous()
{
    lock();
    pCount++;
    //
    // Waiting people just read generation, and the final process
    // just writes it, so we dont really even need to use the locks here.
    //
    if ( pCount == pHeight ) {
	pCount = 0;
	generation++;
	unlock();
    } else {
	int gen = generation;
	VolatileInt *genp = &generation;	// bug in 1.35

	unlock();
	int timesAround = 0;
	int totalGetPids = 0;
	while ( gen == *genp ) {
	    if ( timesAround > pLoops ) {
		(void) getpid();
		timesAround = 0;
		totalGetPids++;
		if ( pMaxLoops > 0 && totalGetPids > pMaxLoops ) {
		    return(0);
		}
	    }
	    timesAround++;

	}
    }
    return(1);
}

void
Tulip_SpinBarrier::height(int newHeight)
{
    lock();
    pCount = 0;
    generation++;
    pHeight = newHeight;
    unlock();
}

