/*=======================================================================
 $Log: Tulip_Thread.C,v $
 Revision 1.1  1998/06/23 00:18:19  ejohnson
 moving directory hpcxx_rts up

 Revision 2.1  1998/06/15 13:11:27  suvas
 *** empty log message ***

 Revision 1.3  1998/05/18 21:44:47  suvas
 *** empty log message ***

 Revision 1.2  1998/05/12 23:16:02  suvas
 This may look like C code, but it is really C++

 Copyright (c) 1998 Los Alamos National Laboratory
 Copyright (c) 1997 University of Colorado, Boulder

 Suvas Vajracharya and Dirk Grunwald

 $Id: Tulip_Thread.C,v 1.1 1998/06/23 00:18:19 ejohnson Exp $
 $Date: 1998/06/23 00:18:19 $
 $Author: ejohnson $
 ========================================================================*/
#ifdef __GNUG__
#  pragma implementation
#endif

#include <iostream.h>
#include "Tulip_Thread.h"
#include "Tulip_Context.h"

Tulip_Mutex Tulip_Thread::numThreadsLock;
int Tulip_Thread::numThreadsCreated=0;

class Tulip_Runnable;


void
Tulip_Thread::_startoff(Tulip_Thread *thread)
{
  thread -> execute();
  //
  // Thread reclaimation goes here..
  //

  Tulip_PrivateContext sys = Tulip_Context::system();
  Tulip_SwitchTo(&(sys -> syscontext),
		 NULL,
		 //		 (Tulip_voidfuncptr*) Tulip_Context::kill_thread, 
		 thread,
		 &(thread -> context));


}
void Tulip_Thread::sleep(long milliseconds, long nanoseconds)
{
  // FIX ME
}

Tulip_Thread::~Tulip_Thread()
{
  if ( stack_malloc_at != NULL ) {
    delete stack_malloc_at;
  }
}

void
Tulip_Thread::_thread_init()
{
  numThreadsLock.lock();
  threadID = ++numThreadsCreated;
  numThreadsLock.unlock();
  state = ALIVE;
  Tulip_InitNP(&context, (Tulip_U64*) stack_end_at, &(Tulip_Thread::_startoff), this);
}

Tulip_Thread::Tulip_Thread(char *name_)
{
  setName(name_);
  _stacksize = default_stack_size;
  stack_malloc_at = new Tulip_U64[_stacksize];
  stack_end_at = &stack_malloc_at[_stacksize-1];
  _thread_init();
}

Tulip_Thread::Tulip_Thread(char *name_, unsigned long stacksize_) 
{
  setName(name_);
  _stacksize = stacksize_;
  stack_malloc_at = new Tulip_U64[_stacksize];
  stack_end_at = &stack_malloc_at[_stacksize-1];
  _thread_init();
}

Tulip_Thread::Tulip_Thread(char *name_, Tulip_U64 *stack_, unsigned long stacksize_) 
{
  setName(name_);
  stack_malloc_at = stack_;
  _stacksize = stacksize_;
  stack_end_at = &stack_malloc_at[_stacksize-1];
  _thread_init();
}
void Tulip_Thread::join(const Tulip_Thread & withThread)
{

  while(withThread.state == ALIVE) {
    Tulip_Context::yield();
  }
}

void 
Tulip_Thread::yield()
{
  Tulip_Context::yield();
}

void Tulip_Thread::suspend()
{
  state = SUSPENDED;
  (Tulip_Context::system())->suspend(this);
}

void Tulip_Thread::resume()
{
  state = ALIVE;
  (Tulip_Context::system())->resume(suspendedAt);
}
















