/***************************************************************************
 *
 * The POOMA Framework
 * 
 * This program was prepared by the Regents of the University of
 * California at Los Alamos National Laboratory (the University) under
 * Contract No.  W-7405-ENG-36 with the U.S. Department of Energy (DOE).
 * The University has certain rights in the program pursuant to the
 * contract and the program should not be copied or distributed outside
 * your organization.  All rights in the program are reserved by the DOE
 * and the University.  Neither the U.S.  Government nor the University
 * makes any warranty, express or implied, or assumes any liability or
 * responsibility for the use of this software
 *
 * Visit http://www.acl.lanl.gov/POOMA for more details
 *
 ***************************************************************************/

#ifndef MYCLASS_H
#define MYCLASS_H

//# include files
#include <stdlib.h>
#include "filename.h"

//# forward references
class ClassName;

//# global defines and enums
#define WOOHOO  Homer

//#*************************************************************************/
//#CLASS|STRUCT|FUNCTION itemname
// <summary> One-line summary of this class </summary>
// <keywords> container iterator etc </keywords>
//
// <motivation>
//   Why the class was written
// </motivation>
// <prerequisite>
//   <li> list of classes which should be understood before this one,
//   <li> using the form on the next line:
//   <li> <linkto class=ClassName> ClassName </linkto>
// </prerequisite>
// If the class is templated, add the following list of requirements
// for each template param 'arg':
// <templating arg=T> Arbitrary : What this arg is for
//   <li> Copy constructor (a requirement)
//   <li> Function 'apply' (another requirement)
// </templating>
// Use <templating arg=T> Arbitrary </templating> for args with no reqs.
//
// <synopsis> [ <user> ]
//   Complete description of this class.  All comments should precede the
//   item they are describing, and be in C++-style comments.  If this class
//   is to be used by POOMA users, bracket the text which provides a synopsis
//   of the class for the user in  <user> ... </user> statements.
//   This description can include:
//     regular text, including regular HTML formatting tags like <i> </i>
//     <srcblock> source code </srcblock>
// [ </user> ] </synopsis>
//
// <method name=methodname>
//   Description of this method
// </method
// <method name=secondname>
//   Another description
// </method>
//
// <inheritance>
//   WHY this class is inherited from what it does
// </inheritance>
// <limitations>
//   <li> Know limitations in this class, if any.  If none, congratulations
//   <li> you can skip this section.
// </limitations>
// <bugs>
//   <li> Known or suspected bugs, one per <li>
// </bugs>
// <todo asof="MM/DD/YYYY">
//   <li> item 1
// </todo>
//
//#*************************************************************************/

template<class T>
class MyClass {

public:
  //# public typedefs
  typedef a b;

  //# public enumerations
  enum MyEnum { HI = 0, THERE = 1 };

  // Constructor documentation.  Can include HTML tags, etc.
  // task = creation
  MyClass(const MyClass<T>&);

  // Destructor documentation.
  // task = destruction
  virtual ~MyClass();

  // <group name=uniquegroupname>
  // Common comments for the following functions

  // Quick description of this function.
  // return = the value of MyValue
  // task = name
  T getValue() const { return MyValue; }

  // Quick description of this function.
  // in v = new value for MyValue
  // task = name
  void setValue(T v) { MyValue = v; }

  // </group>

private:
  // Private variable documentation.
  T MyValue;
};

#endif

/***************************************************************************
 * $RCSfile: template.h,v $   $Author: ejohnson $
 * $Revision: 1.1 $   $Date: 1998/06/23 00:18:48 $
 * POOMA_VERSION_ID: $Id: template.h,v 1.1 1998/06/23 00:18:48 ejohnson Exp $ 
 ***************************************************************************/
