#include <iostream.h>
#include <hpcxx_rts.h>

class MyThread : public HPCxx_Thread {
  HPCxx_CSem* sem;
  HPCxx_Mutex l;
  int& sharedVal;
  int myId;
  
public:
  MyThread(int id, HPCxx_CSem* _sem, int& sv):
    myId(id), sem(_sem), sharedVal(sv), HPCxx_Thread() { }
  
  void run() {
    
    sleep((unsigned)3);
    cout << "Thread " << myId << " waiting for my turn..." << endl << flush;
    
    l.lock(); 
    // begin critical section
    
    cout << "Thread " << myId << " has critical section!" << endl << flush;
    sharedVal += myId;

    // end critical section
    l.unlock();
    
    sem->incr();
    cout << "Thread " << myId << " added in my value (exiting)." 
         << endl << flush;
  } 
};


int main(int argc, char** argv)
{
  HPCxx_Group* g;
  hpcxx_init(argc, argv, g);
  
  int num_threads;
  cout << "enter number of threads: " ;  
  cin >> num_threads;
  
  HPCxx_CSem c(num_threads);
  MyThread* t[num_threads];
  int total = 0;
  
  //
  // Create and begin execution of threads
  //
  int i;
  for(i = 0; i < num_threads; i++) {
    t[i] = new MyThread(i, &c, total);
    t[i]->start();
  }
  
  // Block here until all num_threads have incremented semaphore
  c.wait();
  cout << " Total of thread IDs is : " << total << endl << flush;

  //
  // Wait for threads to finish
  //
  for (i = 0; i < num_threads; i++)
    t[i]->join();
  
  cout << "DONE" << endl << flush;
  hpcxx_exit(g);
  return 0;
}

