#include <math.h>
#include <stdio.h>
#include <limits.h>
#include <iostream.h>
#include <hpcxx_rts.h>
#include <HPCxx_CSem.h>

class SuspdResumeTest : public HPCxx_Thread {
  int myId;
  HPCxx_CSem& c ;
  
public:
  
  SuspdResumeTest(int myId_, HPCxx_CSem& c_) : myId(myId_), c(c_) { }
  
  virtual ~SuspdResumeTest() { }
  
  void run() {
    double x = 1.0;
    int k = 0;
    
    while(k++ < 5) {
      c.incr();

      for(int i = 0; i < 1000000; i++)
	x = sin(x);

      printf("%d: suspending\n", myId);
      this->suspend();
      printf("%d: awake again\n", myId);
    }
  }
  
};


int main(int argc, char** argv)
{
  int nthreads = 0;
  HPCxx_Group* group;
  hpcxx_init(argc, argv, group);

  
  if (argc < 2) {
    cerr << "run as >SuspendResume n  where n is num. of threads\n";
    hpcxx_exit(group);
    return(1);
  } else
    nthreads = atoi(argv[1]);
  
  HPCxx_CSem c(nthreads);
  SuspdResumeTest** suspresmTest;
  suspresmTest = new SuspdResumeTest*[nthreads];

  for(int i = 0; i < nthreads; i++) {
    suspresmTest[i] = new SuspdResumeTest(i, c);
    suspresmTest[i]->start();
  }

  int k = 0;
  while(k++ < 5) {
    c.wait(); 

    char ch;
    printf("hit a key to continue: \n");
    fscanf(stdin, "%c", &ch);

    for(int i = 0; i < nthreads; i++)
      suspresmTest[i]->resume();
  }
  
  for(int j = 0; j < nthreads; j++)
    suspresmTest[j]->join();
  
  hpcxx_exit(group);
  return( 0 );
}
