#include <unistd.h>
#include <stdlib.h>
#include <iostream.h>

// Dummy class so that I can gave a generic pointer for both
// global pointers and member functions
class TableEntry {
};

// Simple struct to hold global function pointers
struct FP : public TableEntry{
  void *fp;
};

// Member function pointer class for no args
template <class R, class C>
class MFP0 : public TableEntry {
  typedef R (C::*Mfp)();

public:
  Mfp mfp;
  MFP0(Mfp mfp_) : mfp(mfp_) {}
};

// Member function pointer class for 1 arg
template <class R, class C, class A1>
class MFP1 : public TableEntry {
  typedef R (C::*Mfp)(A1);

public:
  Mfp mfp;
  MFP1(Mfp mfp_) : mfp(mfp_) {}
};
  
// Duplicate above two for up to 8 args


// Register member function no args
template<class R, class C> int hpcxx_register(R (C::*mfp)())
{
  LUT[tPos] = new MFP0<R, C>(mfp);
  return(tPos++);
}

// Register member function 1 arg
template<class R, class C, class A1> int hpcxx_register(R (C::*mfp)(A1))
{
  LUT[tPos] = new MFP1<R, C, A1>(mfp);
  return(tPos++);
}

// Register global function 1 arg
template<class R, class A1> int hpcxx_register(R (*fp)(A1))
{
  LUT[tPos] = new FP;
  ((FP *)LUT[tPos])->fp = fp;
  return(tPos++);
}

// Invoke a function that returns void and takes no args
template<class C> void invoke(C &c, int id)
{
  typedef void (C::*Mfp)();
  TableEntry *te = LUT[id];
  // The only bit of _evilness_  a cast down their inheritance graph
  Mfp mfp = ((MFP0<void, C> *)te)->mfp;

  (c.*mfp)();
}

// Invoke a function that returns something and takes 1 arg
template<class R, class C, class A1> void invoke(R &r, C &c, int id, A1 &a1)
{
  typedef R (C::*Mfp)(A1);
  TableEntry *te = LUT[id];
  Mfp mfp = ((MFP1<R, C, A1> *)te)->mfp;

  r = (c.*mfp)(a1);
}

// Invoke global function takes one arg
template<class R, class A1> void invoke(R &r, int id, A1 &a1)
{
  typedef R (*Fp)(A1);
  Fp fp = (Fp)((FP *)LUT[id])->fp;

  r = fp(a1);
}

// Some simple classes to test
class C {
public:
  void foo() { cout << "Hello World" << endl; }
};

class D {
public:
  float foo(float f) { return(f); }
};

int foo(int i)
{
  return i;
}

// Global lookup table and position counter
TableEntry *LUT[10];
int        tPos = 0;

void main(void)
{
  int   fId1;
  int   fId2;
  int   fId3;
  int   i;
  float f = 451.0;
  float r;
  C     c;
  D     d;

  fId1 = hpcxx_register(C::foo);
  fId2 = hpcxx_register(D::foo);
  fId3 = hpcxx_register(foo);

  invoke(i, fId3, 5);
  cout << i << endl;
  invoke(c, fId1);
  invoke(r, d, fId2, f);
  cout << r << endl;

  for (i = 0; i < tPos; i++) delete LUT[i];
};
