
#include <stdlib.h>
#include <unistd.h>
#include <stream.h>
#include <signal.h>

#include <nexus.h>
#include <hpcxx_rts.h>
#include "invoke.h"  //i should not be needed.


int quit = 0;

void *_nx_st_rsh_info(void)
{
  return(NULL);
} 

#if defined(sun)
extern "C" {
void *_nx_pr_tcp_info(void)
{
  return(NULL);
}
}

nexus_module_list_t nexus_module_list[] =
{
  {"startups", "rsh", _nx_st_rsh_info},
  {"protocols", "tcp", _nx_pr_tcp_info},
  {NULL, NULL, NULL},
};
#endif

void siggy(int)
{
  quit = 1;
  cerr << "interrupt caught" << endl;
}

char w;
char foo(float z){
  cout << "hi from foo: arg = " << z << endl;
  return w++;
}

int my_context_id;

int blab(int z){
  printf("in context: %d -  Hi from context %d\n", my_context_id, z);
  return my_context_id;
}
void hpcxx_barrier();

int main(int argc, char **argv)
{
  HPCxx_Group *group;
  HPCxx_Sync<int> sync;
  HPCxx_Mutex     mutex;
  HPCxx_Cond      cond;
  hpcxx_id_t      foo_id;

  foo_id = hpcxx_register(foo, 5);
  hpcxx_id_t blab_id = hpcxx_register(blab, 7);

  hpcxx_init(argc, argv, group);
  my_context_id = group->getLocalIndex();

  if (!nexus_master_context()){
     w = 'd';
     hpcxx_barrier();
     }
  else{
    w = 'a';
    HPCxx_ContextID *othercid = group->getContextID(1);
    printf("HPC++ Initialized..\n");
    hpcxx_barrier();

    char result = 0;
    float arg = 337.0;
    hpcxx_invoke(*othercid, result, foo_id,  arg);
    printf("got the result!!! it is = %c\n", result);
    arg = 3.14;
    result = 'p';
    hpcxx_invoke(*othercid, result, foo_id,  arg);
    printf("got the 2nd result!!! it is = %c\n", result);
    arg = 9.99;
    result = 'q';
    hpcxx_invoke(*othercid, result, foo_id,  arg);
    printf("got the 3rd result!!! it is = %c\n", result);
  } // end of master block

  int i;
  int ident = group->getLocalIndex();
  int res;
  for(i = 0; i < group->getNumContexts(); i++){
       hpcxx_invoke(*group->getContextID(i), res, blab_id,  ident);
       printf("return to %d with %d\n", ident, res);
      }
  hpcxx_exit(group);
  return(0);
}
