
#include <stdlib.h>
#include <unistd.h>
#include <stream.h>
#include <signal.h>

#include <nexus.h>
#include <hpcxx_rts.h>
#include "invoke.h"  //i should not be needed.

#define ElapseTime(Start, Stop) \
    (  (  ( ((double)(Stop.tv_sec)) - ((double)(Start.tv_sec)) ) \
        + (((double)(Stop.tv_usec))/1000000.0) ) \
     - (((double)(Start.tv_usec))/1000000.0) )



void *_nx_st_rsh_info(void)
{
  return(NULL);
} 

#if defined(sun)
extern "C" {
void *_nx_pr_tcp_info(void)
{
  return(NULL);
}
}

nexus_module_list_t nexus_module_list[] =
{
  {"startups", "rsh", _nx_st_rsh_info},
  {"protocols", "tcp", _nx_pr_tcp_info},
  {NULL, NULL, NULL},
};
#endif


HPCxx_SyncQ<int> theQ;

int bump(int x){  
   theQ.write(x);
   return 1;
}

int my_context_id;

void hpcxx_barrier();

int main(int argc, char **argv)
{
  int i;
  timeval start_time, stop_time;
  float total_time;
  HPCxx_Group *group;
  int bump_id = hpcxx_register(bump, 99);
  int *list;

  hpcxx_init(argc, argv, group);

  my_context_id = group->getLocalIndex();
  int nc = group->getNumContexts()-1;
  int m = 1000;

  if (my_context_id == 0){
      list = new int[m]; 
      for(i = 0; i < m; i++) list[i] = 0;
      gettimeofday(&start_time, NULL);

      for(i = 0; i < m*nc; i++){
         int j;
         theQ.read(j);
         list[j]++;
       }

      gettimeofday(&stop_time, NULL);
      int errcnt = 0;
      for(i = 0; i < m; i++)
         if(list[i] != nc) errcnt++;
      printf("final errorcnt = %d\n", errcnt);
      total_time = ElapseTime(start_time, stop_time); 
      printf("time per message = %f ms\n", total_time*1000.0/(m*nc)); 
     }
  else{
    HPCxx_ContextID *parent = group->getContextID(0);
    int result = 0;
    
    for(i = 0; i < m; i++)
       hpcxx_invoke(*parent, result, bump_id,  i);
    }

  hpcxx_exit(group);
  return(0);
}
