#include "ReadWriteLock.h"

ReadWriteLock::ReadWriteLock(void) : nReaders(0), nWriters(0)
{
}

int ReadWriteLock::readLock(void)
{
  mutex.lock();
  while (nWriters > 0) {
    forWriter.wait(mutex);
  }
  nReaders += 1;
  mutex.unlock();
  return 0;
}      

int ReadWriteLock::writeLock(void)
{
  mutex.lock();
  while (nWriters > 0 || nReaders > 0) {
    forWriter.wait(mutex);
  }
  nWriters += 1;
  mutex.unlock();
  return 0;
}

int ReadWriteLock::readUnlock(void)
{
  mutex.lock();
  if (nReaders > 0) {
    nReaders -= 1;
    if (nReaders == 0) {
      forWriter.signal();
    }
    mutex.unlock();
    return 0;
  } else {
    // error condition, but not really a problem
    mutex.unlock();
    return -1;
  }
}

int ReadWriteLock::writeUnlock(void)
{
  mutex.lock();
  if (nWriters > 0) {
    nWriters -= 1;
    forWriter.broadcast();
    mutex.unlock();
    return 0;
  } else {
    // error condition, but not really a problem
    mutex.unlock();
    return -1;
  }
}
