#include <stdio.h>
#include <limits.h>
#include <hpcxx_rts.h>
#include <hpcxx_hack.h>
#include <math.h>

class SuspdResumeTest : public HPCxx_Thread {
    
    int myId;
    HPCxx_CSem &c ;
public:

    SuspdResumeTest( int myId_, HPCxx_CSem &c_) : myId(myId_), c(c_){
    }

    virtual ~SuspdResumeTest() {}

    void run( void ) {
        double x = 1.0;
        int k = 0;
        while(k++ < 10){
            c.incr();
            for(int i = 0; i < 1000000; i++) x = sin(x);
            printf("%d: suspending\n", myId);
            this->suspend();
            printf("%d: awake again\n", myId);
        }
    }

};

// Driver
int main( int argc, char *argv[] ) {
    int i = 0;
    int nthreads = 0;
    int myKey = 0;
    int threadRun = 1;
    HPCxx_Group *group = NULL;
    SuspdResumeTest ** suspresmTest;

    if ( argc < 2 ) {
     fprintf( stderr, "run as >SuspendResume n  where n is num. of threads\n");
     hpcxx_exit(group);
     return(1);
    }
    else {
        sscanf( argv[1],  "%d", &nthreads );
    }

    hpcxx_init( argc, argv, group );
    HPCxx_CSem c(nthreads);
    suspresmTest = new SuspdResumeTest*[nthreads];
    for ( i = 0; i < nthreads; i++ ) {
        suspresmTest[i] = new SuspdResumeTest( i, c);
    }

    for ( i = 0; i < nthreads; i++ ) {
        suspresmTest[i]->start();
    }

    for(int j = 0; j < 10; j++){
        c.wait(); 
        char ch;
        printf("hit a key to continue\n");
        fscanf(stdin, "%c", &ch);
        for ( i = 0; i < nthreads; i++ ) {
            suspresmTest[i]->resume();
        }

    }
    for(i = 0; i < nthreads; i++) suspresmTest[i]->join();
    (void) hpcxx_exit( group );

    return( 0 );
}
