#include <stdlib.h>
#include <unistd.h>
#include <stream.h>
#include <signal.h>

#include <nexus.h>
#include <hpcxx_rts.h>
#include <hpcxx_hack.h>

#define ElapseTime(Start, Stop) \
    (  (  ( ((double)(Stop.tv_sec)) - ((double)(Start.tv_sec)) ) \
        + (((double)(Stop.tv_usec))/1000000.0) ) \
     - (((double)(Start.tv_usec))/1000000.0) )

void *_nx_st_rsh_info(void)
{
  return(NULL);
} 
#include <stdio.h>
#define WORKERS 8
#define VSIZE 128
#define TRIES 100

// generated thread subclass 
class Loop1Thread: public HPCxx_Thread{
   int base;
   HPCxx_CSem *c;
   HPCxx_Runnable *theObject;
  public:
    Loop1Thread(HPCxx_Runnable *r, HPCxx_CSem * s, int cnt):
             HPCxx_Thread(r), c(s),  base(cnt){ theObject = r;}
    void run();
};


class Fun: public HPCxx_Runnable{  //converted to Runnable
   float x[VSIZE][VSIZE], y[VSIZE][VSIZE], z[VSIZE][VSIZE];
 public:
    Fun() {
       int k, i; 
       for(k = 0; k < VSIZE; k++)
         for(i = 0; i < VSIZE; i++)
              x[i][k] = y[i][k] = y[i][k] = 1;
      };
    // generated run method
    void run(){}
    void run_loop1( int base, HPCxx_CSem *c ){
       int i,j,k;
       // compute z[base:base+VSIZE/WORKERS][*] = x[base:..][*]*y[*][*]
       for(j = base; j < base+VSIZE/WORKERS; j++){
         float w = 0;
         for(i = 0; i < VSIZE; i++){
             for(k = 0; k < VSIZE; k++)
                w += x[j][k]*y[k][i];
             }
           z[j][i]= w;
          } 
       printf("worker %8d done\n", base);
       c->incr();
    }
     
    void foo(){
       int j,k,i;
       /* original loop
       for(j = 0; j < VSIZE; j++){
          float w = 0;
          for(i = 0; i < VSIZE; i++){
             for(k = 0; k < VSIZE; k++)
                w += x[j][k]*y[k][i];
             }
           z[j][i]= w;
          }
       */
       /* generated code */
       HPCxx_Thread *t[WORKERS];
       HPCxx_CSem *c = new HPCxx_CSem(WORKERS);
       for(int cnt = 0; cnt < WORKERS; cnt++){
          t[cnt] = new Loop1Thread(this,c, VSIZE/WORKERS*cnt);
          t[cnt]->start();
          }
       c->wait();
       }
 };
// generated method 
void Loop1Thread::run(){
        Fun *f = (Fun *) theObject;
        f->run_loop1(base, c);
   }
   

float x[VSIZE][VSIZE], y[VSIZE][VSIZE], z[VSIZE][VSIZE];

// generated thread subclass 
class Loop2Thread: public HPCxx_Thread{
   int base;
   HPCxx_CSem *c;
  public:
    Loop2Thread(HPCxx_Runnable *r, HPCxx_CSem * s,  int cnt):
             HPCxx_Thread(r), c(s), base(cnt){}
    void run(){
       int j, k, i;
       for(int tries = 0; tries < TRIES; tries++){
       // compute z[base:base+VSIZE/WORKERS][*] = x[base:..][*]*y[*][*]
       for(j = base; j < base+VSIZE/WORKERS; j++){
          float w = 0;
          for(i = 0; i < VSIZE; i++){
             for(k = 0; k < VSIZE; k++)
                w += x[j][k]*y[k][i];
             }
           z[j][i]= w;
          } 
       }
       printf("worker %8d done\n", base);
       c->incr();
    }
};

int farb(){
       int j,k,i;
       /* original loop
       for(j = 0; j < VSIZE; j++){
          float w = 0;
          for(i = 0; i < VSIZE; i++){
             for(k = 0; k < VSIZE; k++)
                w += x[j][k]*y[k][i];
             }
           z[j][i]= w;
          }
        */
       // generated code
       HPCxx_Thread *t[WORKERS];
       HPCxx_CSem *c = new HPCxx_CSem(WORKERS);
       for(int cnt = 0; cnt < WORKERS; cnt++){
          t[cnt] = new Loop2Thread(NULL,c, VSIZE/WORKERS*cnt);
          t[cnt]->start();
          }
       c->wait();
      //
     return 0;
}

/*
 * main()
 */
int main(int argc, char **argv)
{
    HPCxx_Group *g;
    hpcxx_init(argc, argv, g);

    // user variables
    int i,j, num_th;
    timeval start_time, stop_time; 
    float work_time, thread_time, thread_cost;
    // end user variables

       int k; 
       for(k = 0; k < VSIZE; k++)
         for(i = 0; i < VSIZE; i++)
              x[i][k] = y[i][k] = y[i][k] = 1;
   
    printf(" up and running!\n");
 for(i = 0; i < 4; i++){
    gettimeofday(&start_time, NULL);
    farb();
    gettimeofday(&stop_time, NULL);
    cout << "done \n";
    thread_time = ElapseTime(start_time, stop_time);
    cout << "time = " << thread_time << " mflops =" 
         << 2.0*VSIZE*VSIZE*VSIZE*TRIES/(thread_time*1.0e6) << endl;
}
    //end of user code
   hpcxx_exit(g);
   return(0);
} /* main() */
    

