//##########################################################################
// HPC++Lib: An object-oriented class library for high performance 
//           parallel programming.
//
// Copyright (c) 1997
//	Indiana University
//	Los Alamos National Laboratory
// 
// http://www.acl.lanl.gov/Tulip
// http://www.extreme.indiana.edu/HPC++
// 
// Pete Beckman, Dennis Gannon, Todd Green, Liz Johnson
//
// HPC++_VER: $Id: HPCxx_CSem.h,v 1.1 1998/06/23 00:55:24 ejohnson Exp $
//##########################################################################

// $Id: HPCxx_CSem.h,v 1.1 1998/06/23 00:55:24 ejohnson Exp $

#ifndef __HPCXX_CSEM_H_
#define __HPCXX_CSEM_H_

#include <HPCxx_Mutex.h>
#include <HPCxx_Cond.h>

//#*************************************************************************/
//#CLASS|STRUCT|FUNCTION itemname
// <summary> One-line summary of this class </summary>
// <keywords> container iterator etc </keywords>
//
// <motivation>
//   Why the class was written
// </motivation>
// <prerequisite>
//   <li> list of classes which should be understood before this one,
//   <li> using the form on the next line:
//#   <li> <linkto class=ClassName> ClassName </linkto>
// </prerequisite>
// If the class is templated, add the following list of requirements
// for each template param 'arg':
// <templating arg=T> Arbitrary : What this arg is for
//   <li> Copy constructor (a requirement)
//   <li> Function 'apply' (another requirement)
// </templating>
// Use <templating arg=T> Arbitrary </templating> for args with no reqs.
//
// <synopsis> [ <user> ]
//   Complete description of this class.  All comments should precede the
//   item they are describing, and be in C++-style comments.  If this class
//   is to be used by POOMA users, bracket the text which provides a synopsis
//   of the class for the user in  <user> ... </user> statements.
//   This description can include:
//     regular text, including regular HTML formatting tags like <i> </i>
//     <srcblock> source code </srcblock>
// [ </user> ] </synopsis>
//
// <method name=methodname>
//   Description of this method
// </method
// <method name=secondname>
//   Another description
// </method>
//
// <inheritance>
//   WHY this class is inherited from what it does
// </inheritance>
// <limitations>
//   <li> Know limitations in this class, if any.  If none, congratulations
//   <li> you can skip this section.
// </limitations>
// <bugs>
//   <li> Known or suspected bugs, one per <li>
// </bugs>
// <todo asof="MM/DD/YYYY">
//   <li> item 1
// </todo>
//
//#*************************************************************************/
class HPCxx_CSem {
private:
  HPCxx_Mutex mutex_;
  HPCxx_Cond  cond_;
  int         val_;
  int         counter_;

public:
  HPCxx_CSem();
  HPCxx_CSem(int val);
  ~HPCxx_CSem();

  void wait();
  void incr();
  int getCount();
  int setCount(int val);
  void operator++();
  int getStatus() { return counter_; }
};

#endif
