//##########################################################################
// HPC++Lib: An object-oriented class library for high performance 
//           parallel programming.
//
// Copyright (c) 1997
//	Indiana University
//	Los Alamos National Laboratory
// 
// http://www.acl.lanl.gov/Tulip
// http://www.extreme.indiana.edu/HPC++
// 
// Pete Beckman, Dennis Gannon, Todd Green, Liz Johnson
//
// HPC++_VER: $Id: HPCxx_Cond.C,v 1.2 1998/08/07 20:24:52 sameer Exp $
//##########################################################################

// $Id: HPCxx_Cond.C,v 1.2 1998/08/07 20:24:52 sameer Exp $

#include <HPCxx_Profile.h>
#include <HPCxx_Cond.h>

HPCxx_Cond::HPCxx_Cond(void)
{
}

HPCxx_Cond::HPCxx_Cond(const HPCxx_Cond &cond) : impl_(cond.impl_)
{
}

HPCxx_Cond& HPCxx_Cond::operator=(const HPCxx_Cond& cond)
{
  TAU_PROFILE("HPCxx_Cond::operator=()", "void (HPCxx_Cond )", TAU_HPCXX);
  if (this == &cond) return *this; // check for self-assignment
  impl_ = cond.impl_;

  return *this;
}

HPCxx_Cond::~HPCxx_Cond(void)
{
}

int HPCxx_Cond::wait(HPCxx_Mutex& mutex)
{
  TAU_PROFILE("HPCxx_Cond::wait()", "int (HPCxx_Mutex)", TAU_HPCXX);
  return(impl_.wait(mutex.impl_));
}

int HPCxx_Cond::signal(void)
{
  TAU_PROFILE("HPCxx_Cond::signal()", "int ()", TAU_HPCXX);
  return(impl_.signal());
}

int HPCxx_Cond::broadcast(void)
{
  TAU_PROFILE("HPCxx_Cond::broadcast()", "int ()", TAU_HPCXX);
  return(impl_.broadcast());
}
