//##########################################################################
// HPC++Lib: An object-oriented class library for high performance 
//           parallel programming.
//
// Copyright (c) 1997
//	Indiana University
//	Los Alamos National Laboratory
// 
// http://www.acl.lanl.gov/Tulip
// http://www.extreme.indiana.edu/HPC++
// 
// Pete Beckman, Dennis Gannon, Todd Green, Liz Johnson
//
// HPC++_VER: $Id: HPCxx_Mutex.C,v 1.2 1998/08/07 20:24:53 sameer Exp $
//##########################################################################

// $Id: HPCxx_Mutex.C,v 1.2 1998/08/07 20:24:53 sameer Exp $

#include <HPCxx_Profile.h>
#include <HPCxx_Mutex.h>

HPCxx_Mutex::HPCxx_Mutex() {}

HPCxx_Mutex::HPCxx_Mutex(const HPCxx_Mutex& mutex) : impl_(mutex.impl_) {}

HPCxx_Mutex& HPCxx_Mutex::operator=(const HPCxx_Mutex& mutex)
{
  if (this == &mutex) return *this; // check for self-assignment
  impl_ = mutex.impl_;

  return *this;
}

HPCxx_Mutex::~HPCxx_Mutex() {}

int HPCxx_Mutex::lock()
{
  TAU_PROFILE("HPCxx_Mutex::lock()", "int ()", TAU_HPCXX);
  return(impl_.lock());
}

int HPCxx_Mutex::unlock()
{
  TAU_PROFILE("HPCxx_Mutex::unlock()", "int ()", TAU_HPCXX);
  return(impl_.unlock());
}
