//##########################################################################
// HPC++Lib: An object-oriented class library for high performance 
//           parallel programming.
// TAU: Tuning and Analysis Utilities.
// Copyright (c) 1997
// 	University of Oregon
//	Indiana University
//	Los Alamos National Laboratory
// 
// http://www.acl.lanl.gov/tau
// http://www.acl.lanl.gov/Tulip
// http://www.extreme.indiana.edu/HPC++
// 
// Sameer Shende, Pete Beckman, Dennis Gannon, Todd Green, Liz Johnson
//
// HPC++_VER: $Id: HPCxx_Profile.h,v 1.2 1998/07/09 23:46:45 sameer Exp $
//##########################################################################

#ifndef _HPCXX_PROFILE_H_
#define _HPCXX_PROFILE_H_

#if (defined(PROFILING_ON) || defined (TRACING_ON))
#include <Profile/Profiler.h>
#else 
/* In the absence of profiling, define the functions as null */
#define TYPE_STRING(profileString, str)
#define PROFILED_BLOCK(name, type)

#define TAU_TYPE_STRING(profileString, str)
#define TAU_PROFILE(name, type, group)
#define TAU_PROFILE_TIMER(var, name, type, group)
#define TAU_PROFILE_START(var)
#define TAU_PROFILE_STOP(var)
#define TAU_PROFILE_STMT(stmt)
#define TAU_PROFILE_EXIT(msg)
#define TAU_PROFILE_INIT(argc, argv)
#define TAU_PROFILE_SET_NODE(node)
#define TAU_PROFILE_SET_CONTEXT(context)
#define TAU_PROFILE_CALLSTACK()

#define TAU_REGISTER_EVENT(event, name)
#define TAU_EVENT(event, data)
#define TAU_EVENT_DISABLE_MIN(event)
#define TAU_EVENT_DISABLE_MAX(event)
#define TAU_EVENT_DISABLE_MEAN(event)
#define TAU_EVENT_DISABLE_STDDEV(event)
#define TAU_STORE_ALL_EVENTS
#define TAU_REGISTER_THREAD()

#define CT(obj)

#define TAU_TRACE_SENDMSG(type, destination, length)
#define TAU_TRACE_RECVMSG(type, source, length)

#endif // PROFILING_ON || TRACING_ON


#endif // _HPCXX_PROFILE_H_ 
