//##########################################################################
// HPC++Lib: An object-oriented class library for high performance 
//           parallel programming.
//
// Copyright (c) 1997
//	Indiana University
//	Los Alamos National Laboratory
// 
// http://www.acl.lanl.gov/Tulip
// http://www.extreme.indiana.edu/HPC++
// 
// Pete Beckman, Dennis Gannon, Todd Green, Liz Johnson
//
// HPC++_VER: $Id: hpcxx_types.h,v 1.3 1998/07/17 14:48:53 rasmussn Exp $
//##########################################################################

#ifndef __HPCXX_TYPES_H_
#define __HPCXX_TYPES_H_

#include <sys/types.h>
#ifndef HPCXX_NO_THREADS
#include <hpcxx_rts_config.h>
#endif
//
// HPC++ typedefs
//

#ifndef HPCXX_NO_THREADS
#ifndef HAVE_BOOL_TYPE
#define HAVE_BOOL_TYPE
typedef enum {false, true} bool;
#endif
#endif
// Implementation specific types
#include <hpcxx_typesImpl.h>

typedef HPCxx_ContextIDImpl HPCxx_ContextID;

//FIXME need to guarantee that hpcxx_id_t is 32 bits
#if defined (sgi)
typedef int32_t hpcxx_id_t;
#else
typedef int hpcxx_id_t;
#endif

struct hpcxx_shmallocator_t { hpcxx_shmallocator_t() {} };
const hpcxx_shmallocator_t HPCXX_NEW;

//
// HPC++ consts
//
const int HPCXX_SUCCESS = 1;
const int HPCXX_FAILURE = 0;

// Thread Constants
const int HCPXX_MAX_THREAD_PRIORITY = 1024;
const int HPCXX_NORM_THREAD_PRIORITY = 512;
const int HPCXX_MIN_THREAD_PRIORITY = 0;

// General Global constants
const int        HPCXX_MAX_NAME_LEN     = 1024;
const int        HPCXX_INVALID_IDSPACE  = -1;
const int        HPCXX_REGISTER_IDSPACE = 0;
const int        HPCXX_GROUP_IDSPACE    = 1;
const hpcxx_id_t HPCXX_INVALID_ID       = -1;
const hpcxx_id_t HPCXX_MIN_LOCAL_ID     = 0;
const hpcxx_id_t HPCXX_MIN_GLOBAL_ID    = -2;
const int        HPCXX_POLL_TIMEOUT     = 1; // in milliseconds
const bool       HPCXX_PREEMPTIVE       = HPCXX_PREEMPTIVE_IMPL_;
const hpcxx_id_t HPCXX_GEN_LOCAL_GROUPID = HPCXX_INVALID_ID;
const hpcxx_id_t HPCXX_GEN_LOCAL_REGISTERID = HPCXX_INVALID_ID;

//literal ID keys for type registration
#define HPCXX_INT_KEY   	10000
#define HPCXX_FLOAT_KEY 	10001
#define HPCXX_SHORT_KEY 	10002
#define HPCXX_U_SHORT_KEY 	10003
#define HPCXX_DOUBLE_KEY 	10004
#define HPCXX_U_INT_KEY         10005
#define HPCXX_LONG_KEY 		10006
#define HPCXX_U_LONG_KEY        10007
#define HPCXX_CHAR_KEY          10008
#define HPCXX_U_CHAR_KEY	10009

// fundamental types
typedef enum {
  HPCXX_TYPE_UNKNOWN = -3,
  HPCXX_TYPE_FUNCTION,
  HPCXX_TYPE_METHOD,
  HPCXX_TYPE_VOID,
  HPCXX_TYPE_CHAR,
  HPCXX_TYPE_SHORT,
  HPCXX_TYPE_INT,
  HPCXX_TYPE_LONG,
  HPCXX_TYPE_FLOAT,
  HPCXX_TYPE_DOUBLE,
  HPCXX_TYPE_STRING,
  HPCXX_TYPE_GP
} hpcxx_type_t;

#endif

