//-----------------------------------------------------------------------------
// Remote.h -- This file contains the declaration and implementation of the
//             Remote class, which demonstations the remote exportation of
//	       an object.
//-----------------------------------------------------------------------------
#ifndef _REMOTE_H
#define _REMOTE_H

#include <CORBA.h>


//-----------------------------------------------------------------------------
// Astract interface for the demonstration remote object.
//-----------------------------------------------------------------------------
class RemoteIntr : public CORBA_Object
{
  public: virtual float mixedSum(int i, float r) = 0;
  public: virtual ~RemoteIntr() {}
};


//-----------------------------------------------------------------------------
// The demonstration object which is to be exported as a remote object.
//-----------------------------------------------------------------------------
class Remote : public RemoteIntr
{
  public:

  Remote(int i, float r) : i_m(i), r_m(r)	{ }
  Remote(void) : i_m(0), r_m(0.0)		{ }

  float mixedSum(int i, float r)
  {
    return i + i_m + r + r_m;
  }

  private:

  int i_m;
  float r_m;

};


#endif	// _REMOTE_H
